# BigQuery API . jobs

## Instance Methods

Requests that a job be cancelled. This call will return immediately, and the client will need to poll for the job status to see if the cancel completed successfully. Cancelled jobs may still incur costs.

Returns information about a specific job. Job information is available for a six month period after creation. Requires that you're the person who ran the job, or have the Is Owner project role.

Retrieves the results of a query job.

Starts a new asynchronous job. Requires the Can View project role.

Lists all jobs that you started in the specified project. Job information is available for a six month period after creation. The job list is sorted in reverse chronological order, by job creation time. Requires the Can View project role, or the Is Owner project role if you set the allUsers property.

Retrieves the next page of results.

Runs a BigQuery SQL query synchronously and returns query results if the query completes within a specified timeout.

### Method Details

`cancel(projectId, jobId)`

    Requests that a job be cancelled. This call will return immediately, and the client will need to poll for the job status to see if the cancel completed successfully. Cancelled jobs may still incur costs.

    Args:
      projectId: string, [Required] Project ID of the job to cancel (required)
      jobId: string, [Required] Job ID of the job to cancel (required)

    Returns:
      An object of the form:

        {
        "job": { # The final state of the job.
            "status": { # [Output-only] The status of this job. Examine this value when polling an asynchronous job to see if the job is complete.
              "state": "A String", # [Output-only] Running state of the job.
              "errors": [ # [Output-only] All errors encountered during the running of the job. Errors here do not necessarily mean that the job has completed or was unsuccessful.
                {
                  "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
                  "message": "A String", # A human-readable description of the error.
                  "reason": "A String", # A short error code that summarizes the error.
                  "location": "A String", # Specifies where the error occurred, if present.
                },
              ],
              "errorResult": { # [Output-only] Final error result of the job. If present, indicates that the job has completed and was unsuccessful.
                "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
                "message": "A String", # A human-readable description of the error.
                "reason": "A String", # A short error code that summarizes the error.
                "location": "A String", # Specifies where the error occurred, if present.
              },
            },
            "kind": "bigquery#job", # [Output-only] The type of the resource.
            "statistics": { # [Output-only] Information about the job, including starting time and ending time of the job.
              "load": { # [Output-only] Statistics for a load job.
                "outputRows": "A String", # [Output-only] Number of rows imported in a load job. Note that while an import job is in the running state, this value may change.
                "inputFiles": "A String", # [Output-only] Number of source files in a load job.
                "inputFileBytes": "A String", # [Output-only] Number of bytes of source data in a load job.
                "outputBytes": "A String", # [Output-only] Size of the loaded data in bytes. Note that while a load job is in the running state, this value may change.
              },
              "creationTime": "A String", # [Output-only] Creation time of this job, in milliseconds since the epoch. This field will be present on all jobs.
              "totalBytesProcessed": "A String", # [Output-only] [Deprecated] Use the bytes processed in the query statistics instead.
              "startTime": "A String", # [Output-only] Start time of this job, in milliseconds since the epoch. This field will be present when the job transitions from the PENDING state to either RUNNING or DONE.
              "query": { # [Output-only] Statistics for a query job.
                "queryPlan": [ # [Output-only, Experimental] Describes execution plan for the query.
                  {
                    "computeRatioMax": 3.14, # Relative amount of time the slowest shard spent on CPU-bound tasks.
                    "recordsWritten": "A String", # Number of records written by the stage.
                    "waitRatioMax": 3.14, # Relative amount of time the slowest shard spent waiting to be scheduled.
                    "readRatioAvg": 3.14, # Relative amount of time the average shard spent reading input.
                    "readRatioMax": 3.14, # Relative amount of time the slowest shard spent reading input.
                    "steps": [ # List of operations within the stage in dependency order (approximately chronological).
                      {
                        "kind": "A String", # Machine-readable operation type.
                        "substeps": [ # Human-readable stage descriptions.
                          "A String",
                        ],
                      },
                    ],
                    "recordsRead": "A String", # Number of records read into the stage.
                    "computeRatioAvg": 3.14, # Relative amount of time the average shard spent on CPU-bound tasks.
                    "writeRatioMax": 3.14, # Relative amount of time the slowest shard spent on writing output.
                    "writeRatioAvg": 3.14, # Relative amount of time the average shard spent on writing output.
                    "waitRatioAvg": 3.14, # Relative amount of time the average shard spent waiting to be scheduled.
                    "id": "A String", # Unique ID for stage within plan.
                    "name": "A String", # Human-readable name for stage.
                  },
                ],
                "statementType": "A String", # [Output-only, Experimental] The type of query statement, if valid.
                "totalBytesBilled": "A String", # [Output-only] Total bytes billed for the job.
                "totalBytesProcessed": "A String", # [Output-only] Total bytes processed for the job.
                "cacheHit": True or False, # [Output-only] Whether the query result was fetched from the query cache.
                "undeclaredQueryParameters": [ # [Output-only, Experimental] Standard SQL only: list of undeclared query parameters detected during a dry run validation.
                  {
                    "parameterType": { # [Required] The type of this parameter.
                      "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                        {
                          "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                          "description": "A String", # [Optional] Human-oriented description of the field.
                          "name": "A String", # [Optional] The name of this field.
                        },
                      ],
                      "type": "A String", # [Required] The top level type of this field.
                      "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                    },
                    "parameterValue": { # [Required] The value of this parameter.
                      "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                        "a_key": # Object with schema name: QueryParameterValue
                      },
                      "arrayValues": [ # [Optional] The array values, if this is an array type.
                        # Object with schema name: QueryParameterValue
                      ],
                      "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                    },
                    "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
                  },
                ],
                "numDmlAffectedRows": "A String", # [Output-only, Experimental] The number of rows affected by a DML statement. Present only for DML statements INSERT, UPDATE or DELETE.
                "billingTier": 42, # [Output-only] Billing tier for the job.
                "referencedTables": [ # [Output-only, Experimental] Referenced tables for the job. Queries that reference more than 50 tables will not have a complete list.
                  {
                    "projectId": "A String", # [Required] The ID of the project containing this table.
                    "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                    "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                  },
                ],
                "schema": { # [Output-only, Experimental] The schema of the results. Present only for successful dry run of non-legacy SQL queries.
                  "fields": [ # Describes the fields in a table.
                    {
                      "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                        # Object with schema name: TableFieldSchema
                      ],
                      "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                      "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                      "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                      "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                    },
                  ],
                },
              },
              "endTime": "A String", # [Output-only] End time of this job, in milliseconds since the epoch. This field will be present whenever a job is in the DONE state.
              "extract": { # [Output-only] Statistics for an extract job.
                "destinationUriFileCounts": [ # [Output-only] Number of files per destination URI or URI pattern specified in the extract configuration. These values will be in the same order as the URIs specified in the 'destinationUris' field.
                  "A String",
                ],
              },
            },
            "jobReference": { # [Optional] Reference describing the unique-per-user name of the job.
              "projectId": "A String", # [Required] The ID of the project containing this job.
              "jobId": "A String", # [Required] The ID of the job. The ID must contain only letters (a-z, A-Z), numbers (0-9), underscores (_), or dashes (-). The maximum length is 1,024 characters.
            },
            "etag": "A String", # [Output-only] A hash of this resource.
            "user_email": "A String", # [Output-only] Email address of the user who ran the job.
            "configuration": { # [Required] Describes the job configuration.
              "load": { # [Pick one] Configures a load job.
                "schemaUpdateOptions": [ # [Experimental] Allows the schema of the desitination table to be updated as a side effect of the load job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
                  "A String",
                ],
                "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
                "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. The separator can be any ISO-8859-1 single-byte character. To use a character in the range 128-255, you must encode the character as UTF8. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
                "autodetect": True or False, # [Experimental] Indicates if we should automatically infer the options and schema for CSV and JSON sources.
                "sourceFormat": "A String", # [Optional] The format of the data files. For CSV files, specify "CSV". For datastore backups, specify "DATASTORE_BACKUP". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro, specify "AVRO". The default value is CSV.
                "destinationTable": { # [Required] The destination table to load the data into.
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
                "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_APPEND. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
                "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when running the job. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid.
                "nullMarker": "A String", # [Optional] This string will be interpreted as a null value when it appears in a CSV file. The default value is the empty string. Please refer to the documentation for further information.
                "allowJaggedRows": True or False, # [Optional] Accept rows that are missing trailing optional columns. The missing values are treated as nulls. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. Only applicable to CSV, ignored for other formats.
                "skipLeadingRows": 42, # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when loading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
                "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud Storage. Each URI can contain one '*' wildcard character and it must come after the 'bucket' name.
                  "A String",
                ],
                "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
                "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
                "schemaInlineFormat": "A String", # [Deprecated] The format of the schemaInline property.
                "schemaInline": "A String", # [Deprecated] The inline schema. For CSV schemas, specify as "Field1:Type1[,Field2:Type2]*". For example, "foo:STRING, bar:INTEGER, baz:FLOAT".
                "allowQuotedNewlines": True or False, # Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
                "projectionFields": [ # [Experimental] If sourceFormat is set to "DATASTORE_BACKUP", indicates which entity properties to load into BigQuery from a Cloud Datastore backup. Property names are case sensitive and must be top-level properties. If no properties are specified, BigQuery loads all properties. If any named property isn't found in the Cloud Datastore backup, an invalid error is returned in the job result.
                  "A String",
                ],
                "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names
                "schema": { # [Optional] The schema for the destination table. The schema can be omitted if the destination table already exists, or if you're loading data from Google Cloud Datastore.
                  "fields": [ # Describes the fields in a table.
                    {
                      "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                        # Object with schema name: TableFieldSchema
                      ],
                      "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                      "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                      "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                      "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                    },
                  ],
                },
              },
              "dryRun": True or False, # [Optional] If set, don't actually run this job. A valid query will return a mostly empty response with some processing statistics, while an invalid query will return the same error it would if it wasn't a dry run. Behavior of non-query jobs is undefined.
              "labels": { # [Experimental] The labels associated with this job. You can use these to organize and group your jobs. Label keys and values can be no longer than 63 characters, can only contain letters, numeric characters, underscores and dashes. International characters are allowed. Label values are optional. Label keys must start with a letter and must be unique within a dataset. Both keys and values are additionally constrained to be <= 128 bytes in size.
                "a_key": "A String",
              },
              "query": { # [Pick one] Configures a query job.
                "flattenResults": true, # [Optional] Flattens all nested and repeated fields in the query results. The default value is true. allowLargeResults must be true if this is set to false.
                "maximumBillingTier": 1, # [Optional] Limits the billing tier for this job. Queries that have resource usage beyond this tier will fail (without incurring a charge). If unspecified, this will be set to your project default.
                "useQueryCache": true, # [Optional] Whether to look for the result in the query cache. The query cache is a best-effort cache that will be flushed whenever tables in the query are modified. Moreover, the query cache is only available when a query does not have a destination table specified. The default value is true.
                "defaultDataset": { # [Optional] Specifies the default dataset to use for unqualified table names in the query.
                  "projectId": "A String", # [Optional] The ID of the project containing this dataset.
                  "datasetId": "A String", # [Required] A unique ID for this dataset, without the project name. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                },
                "useLegacySql": True or False, # Specifies whether to use BigQuery's legacy SQL dialect for this query. The default value is true. If set to false, the query will use BigQuery's standard SQL: https://cloud.google.com/bigquery/sql-reference/ When useLegacySql is set to false, the values of allowLargeResults and flattenResults are ignored; query will be run as if allowLargeResults is true and flattenResults is false.
                "destinationTable": { # [Optional] Describes the table where the query results should be stored. If not present, a new table will be created to store the results.
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
                "schemaUpdateOptions": [ # [Experimental] Allows the schema of the destination table to be updated as a side effect of the query job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
                  "A String",
                ],
                "priority": "A String", # [Optional] Specifies a priority for the query. Possible values include INTERACTIVE and BATCH. The default value is INTERACTIVE.
                "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
                "allowLargeResults": True or False, # If true, allows the query to produce arbitrarily large result tables at a slight cost in performance. Requires destinationTable to be set.
                "userDefinedFunctionResources": [ # [Experimental] Describes user-defined function resources used in the query.
                  {
                    "resourceUri": "A String", # [Pick one] A code resource to load from a Google Cloud Storage URI (gs://bucket/path).
                    "inlineCode": "A String", # [Pick one] An inline resource that contains code for a user-defined function (UDF). Providing a inline code resource is equivalent to providing a URI for a file containing the same code.
                  },
                ],
                "queryParameters": [ # Query parameters for standard SQL queries.
                  {
                    "parameterType": { # [Required] The type of this parameter.
                      "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                        {
                          "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                          "description": "A String", # [Optional] Human-oriented description of the field.
                          "name": "A String", # [Optional] The name of this field.
                        },
                      ],
                      "type": "A String", # [Required] The top level type of this field.
                      "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                    },
                    "parameterValue": { # [Required] The value of this parameter.
                      "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                        "a_key": # Object with schema name: QueryParameterValue
                      },
                      "arrayValues": [ # [Optional] The array values, if this is an array type.
                        # Object with schema name: QueryParameterValue
                      ],
                      "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                    },
                    "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
                  },
                ],
                "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
                "query": "A String", # [Required] BigQuery SQL query to execute.
                "preserveNulls": True or False, # [Deprecated] This property is deprecated.
                "maximumBytesBilled": "A String", # [Optional] Limits the bytes billed for this job. Queries that will have bytes billed beyond this limit will fail (without incurring a charge). If unspecified, this will be set to your project default.
                "tableDefinitions": { # [Optional] If querying an external data source outside of BigQuery, describes the data format, location and other properties of the data source. By defining these properties, the data source can then be queried as if it were a standard BigQuery table.
                  "a_key": {
                    "compression": "A String", # [Optional] The compression type of the data source. Possible values include GZIP and NONE. The default value is NONE. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                    "csvOptions": { # Additional properties to set if sourceFormat is set to CSV.
                      "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
                      "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
                      "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
                      "allowJaggedRows": True or False, # [Optional] Indicates if BigQuery should accept rows that are missing trailing optional columns. If true, BigQuery treats missing trailing columns as null values. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false.
                      "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
                      "allowQuotedNewlines": True or False, # [Optional] Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
                    },
                    "autodetect": True or False, # [Experimental] Try to detect schema and format options automatically. Any option specified explicitly will be honored.
                    "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when reading data. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                    "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names Google Cloud Bigtable: This setting is ignored. Google Cloud Datastore backups: This setting is ignored. Avro: This setting is ignored.
                    "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud. For Google Cloud Storage URIs: Each URI can contain one '*' wildcard character and it must come after the 'bucket' name. Size limits related to load jobs apply to external data sources. For Google Cloud Bigtable URIs: Exactly one URI can be specified and it has be a fully specified and valid HTTPS URL for a Google Cloud Bigtable table. For Google Cloud Datastore backups, exactly one URI can be specified, and it must end with '.backup_info'. Also, the '*' wildcard character is not allowed.
                      "A String",
                    ],
                    "bigtableOptions": { # [Optional] Additional options if sourceFormat is set to BIGTABLE.
                      "readRowkeyAsString": True or False, # [Optional] If field is true, then the rowkey column families will be read and converted to string. Otherwise they are read with BYTES type values and users need to manually cast them with CAST if necessary. The default value is false.
                      "ignoreUnspecifiedColumnFamilies": True or False, # [Optional] If field is true, then the column families that are not specified in columnFamilies list are not exposed in the table schema. Otherwise, they are read with BYTES type values. The default value is false.
                      "columnFamilies": [ # [Optional] List of column families to expose in the table schema along with their types. This list restricts the column families that can be referenced in queries and specifies their value types. You can use this list to do type conversions - see the 'type' field for more details. If you leave this list empty, all column families are present in the table schema and their values are read as BYTES. During a query only the column families referenced in that query are read from Bigtable.
                        {
                          "familyId": "A String", # Identifier of the column family.
                          "type": "A String", # [Optional] The type to convert the value in cells of this column family. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. This can be overridden for a specific column by listing that column in 'columns' and specifying a type for it.
                          "onlyReadLatest": True or False, # [Optional] If this is set only the latest version of value are exposed for all columns in this column family. This can be overridden for a specific column by listing that column in 'columns' and specifying a different setting for that column.
                          "columns": [ # [Optional] Lists of columns that should be exposed as individual fields as opposed to a list of (column name, value) pairs. All columns whose qualifier matches a qualifier in this list can be accessed as .. Other columns can be accessed as a list through .Column field.
                            {
                              "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. 'encoding' can also be set at the column family level. However, the setting at this level takes precedence if 'encoding' is set at both levels.
                              "qualifierEncoded": "A String", # [Required] Qualifier of the column. Columns in the parent column family that has this exact qualifier are exposed as . field. If the qualifier is valid UTF-8 string, it can be specified in the qualifier_string field. Otherwise, a base-64 encoded value must be set to qualifier_encoded. The column field name is the same as the column qualifier. However, if the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as field_name.
                              "fieldName": "A String", # [Optional] If the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as the column field name and is used as field name in queries.
                              "onlyReadLatest": True or False, # [Optional] If this is set, only the latest version of value in this column are exposed. 'onlyReadLatest' can also be set at the column family level. However, the setting at this level takes precedence if 'onlyReadLatest' is set at both levels.
                              "qualifierString": "A String",
                              "type": "A String", # [Optional] The type to convert the value in cells of this column. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. 'type' can also be set at the column family level. However, the setting at this level takes precedence if 'type' is set at both levels.
                            },
                          ],
                          "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. This can be overridden for a specific column by listing that column in 'columns' and specifying an encoding for it.
                        },
                      ],
                    },
                    "sourceFormat": "A String", # [Required] The data format. For CSV files, specify "CSV". For Google sheets, specify "GOOGLE_SHEETS". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro files, specify "AVRO". For Google Cloud Datastore backups, specify "DATASTORE_BACKUP". [Experimental] For Google Cloud Bigtable, specify "BIGTABLE". Please note that reading from Google Cloud Bigtable is experimental and has to be enabled for your project. Please contact Google Cloud Support to enable this for your project.
                    "googleSheetsOptions": { # [Optional] Additional options if sourceFormat is set to GOOGLE_SHEETS.
                      "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a sheet that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows that should be skipped. When autodetect is on, behavior is the following: * skipLeadingRows unspecified - Autodetect tries to detect headers in the first row. If they are not detected, the row is read as data. Otherwise data is read starting from the second row. * skipLeadingRows is 0 - Instructs autodetect that there are no headers and data should be read starting from the first row. * skipLeadingRows = N > 0 - Autodetect skips N-1 rows and tries to detect headers in row N. If headers are not detected, row N is just skipped. Otherwise row N is used to extract column names for the detected schema.
                    },
                    "schema": { # [Optional] The schema for the data. Schema is required for CSV and JSON formats. Schema is disallowed for Google Cloud Bigtable, Cloud Datastore backups, and Avro formats.
                      "fields": [ # Describes the fields in a table.
                        {
                          "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                            # Object with schema name: TableFieldSchema
                          ],
                          "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                          "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                          "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                          "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                        },
                      ],
                    },
                  },
                },
                "parameterMode": "A String", # [Experimental] Standard SQL only. Whether to use positional (?) or named (@myparam) query parameters in this query.
              },
              "copy": { # [Pick one] Copies a table.
                "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
                "sourceTables": [ # [Pick one] Source tables to copy.
                  {
                    "projectId": "A String", # [Required] The ID of the project containing this table.
                    "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                    "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                  },
                ],
                "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
                "destinationTable": { # [Required] The destination table
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
                "sourceTable": { # [Pick one] Source table to copy.
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
              },
              "extract": { # [Pick one] Configures an extract job.
                "destinationUri": "A String", # [Pick one] DEPRECATED: Use destinationUris instead, passing only one URI as necessary. The fully-qualified Google Cloud Storage URI where the extracted table should be written.
                "compression": "A String", # [Optional] The compression type to use for exported files. Possible values include GZIP and NONE. The default value is NONE.
                "fieldDelimiter": "A String", # [Optional] Delimiter to use between fields in the exported data. Default is ','
                "destinationFormat": "A String", # [Optional] The exported file format. Possible values include CSV, NEWLINE_DELIMITED_JSON and AVRO. The default value is CSV. Tables with nested or repeated fields cannot be exported as CSV.
                "printHeader": true, # [Optional] Whether to print out a header row in the results. Default is true.
                "destinationUris": [ # [Pick one] A list of fully-qualified Google Cloud Storage URIs where the extracted table should be written.
                  "A String",
                ],
                "sourceTable": { # [Required] A reference to the table being exported.
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
              },
            },
            "id": "A String", # [Output-only] Opaque ID field of the job
            "selfLink": "A String", # [Output-only] A URL that can be used to access this resource again.
          },
        "kind": "bigquery#jobCancelResponse", # The resource type of the response.
      }

`get(projectId, jobId)`

    Returns information about a specific job. Job information is available for a six month period after creation. Requires that you're the person who ran the job, or have the Is Owner project role.

    Args:
      projectId: string, [Required] Project ID of the requested job (required)
      jobId: string, [Required] Job ID of the requested job (required)

    Returns:
      An object of the form:

        {
          "status": { # [Output-only] The status of this job. Examine this value when polling an asynchronous job to see if the job is complete.
            "state": "A String", # [Output-only] Running state of the job.
            "errors": [ # [Output-only] All errors encountered during the running of the job. Errors here do not necessarily mean that the job has completed or was unsuccessful.
              {
                "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
                "message": "A String", # A human-readable description of the error.
                "reason": "A String", # A short error code that summarizes the error.
                "location": "A String", # Specifies where the error occurred, if present.
              },
            ],
            "errorResult": { # [Output-only] Final error result of the job. If present, indicates that the job has completed and was unsuccessful.
              "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
              "message": "A String", # A human-readable description of the error.
              "reason": "A String", # A short error code that summarizes the error.
              "location": "A String", # Specifies where the error occurred, if present.
            },
          },
          "kind": "bigquery#job", # [Output-only] The type of the resource.
          "statistics": { # [Output-only] Information about the job, including starting time and ending time of the job.
            "load": { # [Output-only] Statistics for a load job.
              "outputRows": "A String", # [Output-only] Number of rows imported in a load job. Note that while an import job is in the running state, this value may change.
              "inputFiles": "A String", # [Output-only] Number of source files in a load job.
              "inputFileBytes": "A String", # [Output-only] Number of bytes of source data in a load job.
              "outputBytes": "A String", # [Output-only] Size of the loaded data in bytes. Note that while a load job is in the running state, this value may change.
            },
            "creationTime": "A String", # [Output-only] Creation time of this job, in milliseconds since the epoch. This field will be present on all jobs.
            "totalBytesProcessed": "A String", # [Output-only] [Deprecated] Use the bytes processed in the query statistics instead.
            "startTime": "A String", # [Output-only] Start time of this job, in milliseconds since the epoch. This field will be present when the job transitions from the PENDING state to either RUNNING or DONE.
            "query": { # [Output-only] Statistics for a query job.
              "queryPlan": [ # [Output-only, Experimental] Describes execution plan for the query.
                {
                  "computeRatioMax": 3.14, # Relative amount of time the slowest shard spent on CPU-bound tasks.
                  "recordsWritten": "A String", # Number of records written by the stage.
                  "waitRatioMax": 3.14, # Relative amount of time the slowest shard spent waiting to be scheduled.
                  "readRatioAvg": 3.14, # Relative amount of time the average shard spent reading input.
                  "readRatioMax": 3.14, # Relative amount of time the slowest shard spent reading input.
                  "steps": [ # List of operations within the stage in dependency order (approximately chronological).
                    {
                      "kind": "A String", # Machine-readable operation type.
                      "substeps": [ # Human-readable stage descriptions.
                        "A String",
                      ],
                    },
                  ],
                  "recordsRead": "A String", # Number of records read into the stage.
                  "computeRatioAvg": 3.14, # Relative amount of time the average shard spent on CPU-bound tasks.
                  "writeRatioMax": 3.14, # Relative amount of time the slowest shard spent on writing output.
                  "writeRatioAvg": 3.14, # Relative amount of time the average shard spent on writing output.
                  "waitRatioAvg": 3.14, # Relative amount of time the average shard spent waiting to be scheduled.
                  "id": "A String", # Unique ID for stage within plan.
                  "name": "A String", # Human-readable name for stage.
                },
              ],
              "statementType": "A String", # [Output-only, Experimental] The type of query statement, if valid.
              "totalBytesBilled": "A String", # [Output-only] Total bytes billed for the job.
              "totalBytesProcessed": "A String", # [Output-only] Total bytes processed for the job.
              "cacheHit": True or False, # [Output-only] Whether the query result was fetched from the query cache.
              "undeclaredQueryParameters": [ # [Output-only, Experimental] Standard SQL only: list of undeclared query parameters detected during a dry run validation.
                {
                  "parameterType": { # [Required] The type of this parameter.
                    "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                      {
                        "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                        "description": "A String", # [Optional] Human-oriented description of the field.
                        "name": "A String", # [Optional] The name of this field.
                      },
                    ],
                    "type": "A String", # [Required] The top level type of this field.
                    "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                  },
                  "parameterValue": { # [Required] The value of this parameter.
                    "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                      "a_key": # Object with schema name: QueryParameterValue
                    },
                    "arrayValues": [ # [Optional] The array values, if this is an array type.
                      # Object with schema name: QueryParameterValue
                    ],
                    "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                  },
                  "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
                },
              ],
              "numDmlAffectedRows": "A String", # [Output-only, Experimental] The number of rows affected by a DML statement. Present only for DML statements INSERT, UPDATE or DELETE.
              "billingTier": 42, # [Output-only] Billing tier for the job.
              "referencedTables": [ # [Output-only, Experimental] Referenced tables for the job. Queries that reference more than 50 tables will not have a complete list.
                {
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
              ],
              "schema": { # [Output-only, Experimental] The schema of the results. Present only for successful dry run of non-legacy SQL queries.
                "fields": [ # Describes the fields in a table.
                  {
                    "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                      # Object with schema name: TableFieldSchema
                    ],
                    "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                    "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                    "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                    "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                  },
                ],
              },
            },
            "endTime": "A String", # [Output-only] End time of this job, in milliseconds since the epoch. This field will be present whenever a job is in the DONE state.
            "extract": { # [Output-only] Statistics for an extract job.
              "destinationUriFileCounts": [ # [Output-only] Number of files per destination URI or URI pattern specified in the extract configuration. These values will be in the same order as the URIs specified in the 'destinationUris' field.
                "A String",
              ],
            },
          },
          "jobReference": { # [Optional] Reference describing the unique-per-user name of the job.
            "projectId": "A String", # [Required] The ID of the project containing this job.
            "jobId": "A String", # [Required] The ID of the job. The ID must contain only letters (a-z, A-Z), numbers (0-9), underscores (_), or dashes (-). The maximum length is 1,024 characters.
          },
          "etag": "A String", # [Output-only] A hash of this resource.
          "user_email": "A String", # [Output-only] Email address of the user who ran the job.
          "configuration": { # [Required] Describes the job configuration.
            "load": { # [Pick one] Configures a load job.
              "schemaUpdateOptions": [ # [Experimental] Allows the schema of the desitination table to be updated as a side effect of the load job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
                "A String",
              ],
              "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
              "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. The separator can be any ISO-8859-1 single-byte character. To use a character in the range 128-255, you must encode the character as UTF8. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
              "autodetect": True or False, # [Experimental] Indicates if we should automatically infer the options and schema for CSV and JSON sources.
              "sourceFormat": "A String", # [Optional] The format of the data files. For CSV files, specify "CSV". For datastore backups, specify "DATASTORE_BACKUP". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro, specify "AVRO". The default value is CSV.
              "destinationTable": { # [Required] The destination table to load the data into.
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
              "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_APPEND. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
              "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when running the job. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid.
              "nullMarker": "A String", # [Optional] This string will be interpreted as a null value when it appears in a CSV file. The default value is the empty string. Please refer to the documentation for further information.
              "allowJaggedRows": True or False, # [Optional] Accept rows that are missing trailing optional columns. The missing values are treated as nulls. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. Only applicable to CSV, ignored for other formats.
              "skipLeadingRows": 42, # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when loading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
              "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud Storage. Each URI can contain one '*' wildcard character and it must come after the 'bucket' name.
                "A String",
              ],
              "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
              "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
              "schemaInlineFormat": "A String", # [Deprecated] The format of the schemaInline property.
              "schemaInline": "A String", # [Deprecated] The inline schema. For CSV schemas, specify as "Field1:Type1[,Field2:Type2]*". For example, "foo:STRING, bar:INTEGER, baz:FLOAT".
              "allowQuotedNewlines": True or False, # Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
              "projectionFields": [ # [Experimental] If sourceFormat is set to "DATASTORE_BACKUP", indicates which entity properties to load into BigQuery from a Cloud Datastore backup. Property names are case sensitive and must be top-level properties. If no properties are specified, BigQuery loads all properties. If any named property isn't found in the Cloud Datastore backup, an invalid error is returned in the job result.
                "A String",
              ],
              "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names
              "schema": { # [Optional] The schema for the destination table. The schema can be omitted if the destination table already exists, or if you're loading data from Google Cloud Datastore.
                "fields": [ # Describes the fields in a table.
                  {
                    "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                      # Object with schema name: TableFieldSchema
                    ],
                    "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                    "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                    "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                    "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                  },
                ],
              },
            },
            "dryRun": True or False, # [Optional] If set, don't actually run this job. A valid query will return a mostly empty response with some processing statistics, while an invalid query will return the same error it would if it wasn't a dry run. Behavior of non-query jobs is undefined.
            "labels": { # [Experimental] The labels associated with this job. You can use these to organize and group your jobs. Label keys and values can be no longer than 63 characters, can only contain letters, numeric characters, underscores and dashes. International characters are allowed. Label values are optional. Label keys must start with a letter and must be unique within a dataset. Both keys and values are additionally constrained to be <= 128 bytes in size.
              "a_key": "A String",
            },
            "query": { # [Pick one] Configures a query job.
              "flattenResults": true, # [Optional] Flattens all nested and repeated fields in the query results. The default value is true. allowLargeResults must be true if this is set to false.
              "maximumBillingTier": 1, # [Optional] Limits the billing tier for this job. Queries that have resource usage beyond this tier will fail (without incurring a charge). If unspecified, this will be set to your project default.
              "useQueryCache": true, # [Optional] Whether to look for the result in the query cache. The query cache is a best-effort cache that will be flushed whenever tables in the query are modified. Moreover, the query cache is only available when a query does not have a destination table specified. The default value is true.
              "defaultDataset": { # [Optional] Specifies the default dataset to use for unqualified table names in the query.
                "projectId": "A String", # [Optional] The ID of the project containing this dataset.
                "datasetId": "A String", # [Required] A unique ID for this dataset, without the project name. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
              },
              "useLegacySql": True or False, # Specifies whether to use BigQuery's legacy SQL dialect for this query. The default value is true. If set to false, the query will use BigQuery's standard SQL: https://cloud.google.com/bigquery/sql-reference/ When useLegacySql is set to false, the values of allowLargeResults and flattenResults are ignored; query will be run as if allowLargeResults is true and flattenResults is false.
              "destinationTable": { # [Optional] Describes the table where the query results should be stored. If not present, a new table will be created to store the results.
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
              "schemaUpdateOptions": [ # [Experimental] Allows the schema of the destination table to be updated as a side effect of the query job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
                "A String",
              ],
              "priority": "A String", # [Optional] Specifies a priority for the query. Possible values include INTERACTIVE and BATCH. The default value is INTERACTIVE.
              "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
              "allowLargeResults": True or False, # If true, allows the query to produce arbitrarily large result tables at a slight cost in performance. Requires destinationTable to be set.
              "userDefinedFunctionResources": [ # [Experimental] Describes user-defined function resources used in the query.
                {
                  "resourceUri": "A String", # [Pick one] A code resource to load from a Google Cloud Storage URI (gs://bucket/path).
                  "inlineCode": "A String", # [Pick one] An inline resource that contains code for a user-defined function (UDF). Providing a inline code resource is equivalent to providing a URI for a file containing the same code.
                },
              ],
              "queryParameters": [ # Query parameters for standard SQL queries.
                {
                  "parameterType": { # [Required] The type of this parameter.
                    "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                      {
                        "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                        "description": "A String", # [Optional] Human-oriented description of the field.
                        "name": "A String", # [Optional] The name of this field.
                      },
                    ],
                    "type": "A String", # [Required] The top level type of this field.
                    "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                  },
                  "parameterValue": { # [Required] The value of this parameter.
                    "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                      "a_key": # Object with schema name: QueryParameterValue
                    },
                    "arrayValues": [ # [Optional] The array values, if this is an array type.
                      # Object with schema name: QueryParameterValue
                    ],
                    "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                  },
                  "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
                },
              ],
              "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
              "query": "A String", # [Required] BigQuery SQL query to execute.
              "preserveNulls": True or False, # [Deprecated] This property is deprecated.
              "maximumBytesBilled": "A String", # [Optional] Limits the bytes billed for this job. Queries that will have bytes billed beyond this limit will fail (without incurring a charge). If unspecified, this will be set to your project default.
              "tableDefinitions": { # [Optional] If querying an external data source outside of BigQuery, describes the data format, location and other properties of the data source. By defining these properties, the data source can then be queried as if it were a standard BigQuery table.
                "a_key": {
                  "compression": "A String", # [Optional] The compression type of the data source. Possible values include GZIP and NONE. The default value is NONE. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                  "csvOptions": { # Additional properties to set if sourceFormat is set to CSV.
                    "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
                    "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
                    "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
                    "allowJaggedRows": True or False, # [Optional] Indicates if BigQuery should accept rows that are missing trailing optional columns. If true, BigQuery treats missing trailing columns as null values. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false.
                    "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
                    "allowQuotedNewlines": True or False, # [Optional] Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
                  },
                  "autodetect": True or False, # [Experimental] Try to detect schema and format options automatically. Any option specified explicitly will be honored.
                  "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when reading data. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                  "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names Google Cloud Bigtable: This setting is ignored. Google Cloud Datastore backups: This setting is ignored. Avro: This setting is ignored.
                  "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud. For Google Cloud Storage URIs: Each URI can contain one '*' wildcard character and it must come after the 'bucket' name. Size limits related to load jobs apply to external data sources. For Google Cloud Bigtable URIs: Exactly one URI can be specified and it has be a fully specified and valid HTTPS URL for a Google Cloud Bigtable table. For Google Cloud Datastore backups, exactly one URI can be specified, and it must end with '.backup_info'. Also, the '*' wildcard character is not allowed.
                    "A String",
                  ],
                  "bigtableOptions": { # [Optional] Additional options if sourceFormat is set to BIGTABLE.
                    "readRowkeyAsString": True or False, # [Optional] If field is true, then the rowkey column families will be read and converted to string. Otherwise they are read with BYTES type values and users need to manually cast them with CAST if necessary. The default value is false.
                    "ignoreUnspecifiedColumnFamilies": True or False, # [Optional] If field is true, then the column families that are not specified in columnFamilies list are not exposed in the table schema. Otherwise, they are read with BYTES type values. The default value is false.
                    "columnFamilies": [ # [Optional] List of column families to expose in the table schema along with their types. This list restricts the column families that can be referenced in queries and specifies their value types. You can use this list to do type conversions - see the 'type' field for more details. If you leave this list empty, all column families are present in the table schema and their values are read as BYTES. During a query only the column families referenced in that query are read from Bigtable.
                      {
                        "familyId": "A String", # Identifier of the column family.
                        "type": "A String", # [Optional] The type to convert the value in cells of this column family. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. This can be overridden for a specific column by listing that column in 'columns' and specifying a type for it.
                        "onlyReadLatest": True or False, # [Optional] If this is set only the latest version of value are exposed for all columns in this column family. This can be overridden for a specific column by listing that column in 'columns' and specifying a different setting for that column.
                        "columns": [ # [Optional] Lists of columns that should be exposed as individual fields as opposed to a list of (column name, value) pairs. All columns whose qualifier matches a qualifier in this list can be accessed as .. Other columns can be accessed as a list through .Column field.
                          {
                            "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. 'encoding' can also be set at the column family level. However, the setting at this level takes precedence if 'encoding' is set at both levels.
                            "qualifierEncoded": "A String", # [Required] Qualifier of the column. Columns in the parent column family that has this exact qualifier are exposed as . field. If the qualifier is valid UTF-8 string, it can be specified in the qualifier_string field. Otherwise, a base-64 encoded value must be set to qualifier_encoded. The column field name is the same as the column qualifier. However, if the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as field_name.
                            "fieldName": "A String", # [Optional] If the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as the column field name and is used as field name in queries.
                            "onlyReadLatest": True or False, # [Optional] If this is set, only the latest version of value in this column are exposed. 'onlyReadLatest' can also be set at the column family level. However, the setting at this level takes precedence if 'onlyReadLatest' is set at both levels.
                            "qualifierString": "A String",
                            "type": "A String", # [Optional] The type to convert the value in cells of this column. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. 'type' can also be set at the column family level. However, the setting at this level takes precedence if 'type' is set at both levels.
                          },
                        ],
                        "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. This can be overridden for a specific column by listing that column in 'columns' and specifying an encoding for it.
                      },
                    ],
                  },
                  "sourceFormat": "A String", # [Required] The data format. For CSV files, specify "CSV". For Google sheets, specify "GOOGLE_SHEETS". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro files, specify "AVRO". For Google Cloud Datastore backups, specify "DATASTORE_BACKUP". [Experimental] For Google Cloud Bigtable, specify "BIGTABLE". Please note that reading from Google Cloud Bigtable is experimental and has to be enabled for your project. Please contact Google Cloud Support to enable this for your project.
                  "googleSheetsOptions": { # [Optional] Additional options if sourceFormat is set to GOOGLE_SHEETS.
                    "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a sheet that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows that should be skipped. When autodetect is on, behavior is the following: * skipLeadingRows unspecified - Autodetect tries to detect headers in the first row. If they are not detected, the row is read as data. Otherwise data is read starting from the second row. * skipLeadingRows is 0 - Instructs autodetect that there are no headers and data should be read starting from the first row. * skipLeadingRows = N > 0 - Autodetect skips N-1 rows and tries to detect headers in row N. If headers are not detected, row N is just skipped. Otherwise row N is used to extract column names for the detected schema.
                  },
                  "schema": { # [Optional] The schema for the data. Schema is required for CSV and JSON formats. Schema is disallowed for Google Cloud Bigtable, Cloud Datastore backups, and Avro formats.
                    "fields": [ # Describes the fields in a table.
                      {
                        "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                          # Object with schema name: TableFieldSchema
                        ],
                        "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                        "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                        "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                        "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                      },
                    ],
                  },
                },
              },
              "parameterMode": "A String", # [Experimental] Standard SQL only. Whether to use positional (?) or named (@myparam) query parameters in this query.
            },
            "copy": { # [Pick one] Copies a table.
              "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
              "sourceTables": [ # [Pick one] Source tables to copy.
                {
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
              ],
              "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
              "destinationTable": { # [Required] The destination table
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
              "sourceTable": { # [Pick one] Source table to copy.
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
            },
            "extract": { # [Pick one] Configures an extract job.
              "destinationUri": "A String", # [Pick one] DEPRECATED: Use destinationUris instead, passing only one URI as necessary. The fully-qualified Google Cloud Storage URI where the extracted table should be written.
              "compression": "A String", # [Optional] The compression type to use for exported files. Possible values include GZIP and NONE. The default value is NONE.
              "fieldDelimiter": "A String", # [Optional] Delimiter to use between fields in the exported data. Default is ','
              "destinationFormat": "A String", # [Optional] The exported file format. Possible values include CSV, NEWLINE_DELIMITED_JSON and AVRO. The default value is CSV. Tables with nested or repeated fields cannot be exported as CSV.
              "printHeader": true, # [Optional] Whether to print out a header row in the results. Default is true.
              "destinationUris": [ # [Pick one] A list of fully-qualified Google Cloud Storage URIs where the extracted table should be written.
                "A String",
              ],
              "sourceTable": { # [Required] A reference to the table being exported.
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
            },
          },
          "id": "A String", # [Output-only] Opaque ID field of the job
          "selfLink": "A String", # [Output-only] A URL that can be used to access this resource again.
        }

`getQueryResults(projectId, jobId, timeoutMs=None, pageToken=None, maxResults=None, startIndex=None)`

    Retrieves the results of a query job.

    Args:
      projectId: string, [Required] Project ID of the query job (required)
      jobId: string, [Required] Job ID of the query job (required)
      timeoutMs: integer, How long to wait for the query to complete, in milliseconds, before returning. Default is 10 seconds. If the timeout passes before the job completes, the 'jobComplete' field in the response will be false
      pageToken: string, Page token, returned by a previous call, to request the next page of results
      maxResults: integer, Maximum number of results to read
      startIndex: string, Zero-based index of the starting row

    Returns:
      An object of the form:

        {
        "kind": "bigquery#getQueryResultsResponse", # The resource type of the response.
        "errors": [ # [Output-only] All errors and warnings encountered during the running of the job. Errors here do not necessarily mean that the job has completed or was unsuccessful.
          {
            "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
            "message": "A String", # A human-readable description of the error.
            "reason": "A String", # A short error code that summarizes the error.
            "location": "A String", # Specifies where the error occurred, if present.
          },
        ],
        "jobReference": { # Reference to the BigQuery Job that was created to run the query. This field will be present even if the original request timed out, in which case GetQueryResults can be used to read the results once the query has completed. Since this API only returns the first page of results, subsequent pages can be fetched via the same mechanism (GetQueryResults).
          "projectId": "A String", # [Required] The ID of the project containing this job.
          "jobId": "A String", # [Required] The ID of the job. The ID must contain only letters (a-z, A-Z), numbers (0-9), underscores (_), or dashes (-). The maximum length is 1,024 characters.
        },
        "pageToken": "A String", # A token used for paging results.
        "jobComplete": True or False, # Whether the query has completed or not. If rows or totalRows are present, this will always be true. If this is false, totalRows will not be available.
        "totalRows": "A String", # The total number of rows in the complete query result set, which can be more than the number of rows in this single page of results. Present only when the query completes successfully.
        "totalBytesProcessed": "A String", # The total number of bytes processed for this query.
        "cacheHit": True or False, # Whether the query result was fetched from the query cache.
        "etag": "A String", # A hash of this response.
        "rows": [ # An object with as many results as can be contained within the maximum permitted reply size. To get any additional rows, you can call GetQueryResults and specify the jobReference returned above. Present only when the query completes successfully.
          {
            "f": [ # Represents a single row in the result set, consisting of one or more fields.
              {
                "v": "",
              },
            ],
          },
        ],
        "numDmlAffectedRows": "A String", # [Output-only, Experimental] The number of rows affected by a DML statement. Present only for DML statements INSERT, UPDATE or DELETE.
        "schema": { # The schema of the results. Present only when the query completes successfully.
          "fields": [ # Describes the fields in a table.
            {
              "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                # Object with schema name: TableFieldSchema
              ],
              "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
              "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
              "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
              "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
            },
          ],
        },
      }

`insert(projectId, body=None, media_body=None, media_mime_type=None)`

    Starts a new asynchronous job. Requires the Can View project role.

    Args:
      projectId: string, Project ID of the project that will be billed for the job (required)
      body: object, The request body.
        The object takes the form of:

    {
        "status": { # [Output-only] The status of this job. Examine this value when polling an asynchronous job to see if the job is complete.
          "state": "A String", # [Output-only] Running state of the job.
          "errors": [ # [Output-only] All errors encountered during the running of the job. Errors here do not necessarily mean that the job has completed or was unsuccessful.
            {
              "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
              "message": "A String", # A human-readable description of the error.
              "reason": "A String", # A short error code that summarizes the error.
              "location": "A String", # Specifies where the error occurred, if present.
            },
          ],
          "errorResult": { # [Output-only] Final error result of the job. If present, indicates that the job has completed and was unsuccessful.
            "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
            "message": "A String", # A human-readable description of the error.
            "reason": "A String", # A short error code that summarizes the error.
            "location": "A String", # Specifies where the error occurred, if present.
          },
        },
        "kind": "bigquery#job", # [Output-only] The type of the resource.
        "statistics": { # [Output-only] Information about the job, including starting time and ending time of the job.
          "load": { # [Output-only] Statistics for a load job.
            "outputRows": "A String", # [Output-only] Number of rows imported in a load job. Note that while an import job is in the running state, this value may change.
            "inputFiles": "A String", # [Output-only] Number of source files in a load job.
            "inputFileBytes": "A String", # [Output-only] Number of bytes of source data in a load job.
            "outputBytes": "A String", # [Output-only] Size of the loaded data in bytes. Note that while a load job is in the running state, this value may change.
          },
          "creationTime": "A String", # [Output-only] Creation time of this job, in milliseconds since the epoch. This field will be present on all jobs.
          "totalBytesProcessed": "A String", # [Output-only] [Deprecated] Use the bytes processed in the query statistics instead.
          "startTime": "A String", # [Output-only] Start time of this job, in milliseconds since the epoch. This field will be present when the job transitions from the PENDING state to either RUNNING or DONE.
          "query": { # [Output-only] Statistics for a query job.
            "queryPlan": [ # [Output-only, Experimental] Describes execution plan for the query.
              {
                "computeRatioMax": 3.14, # Relative amount of time the slowest shard spent on CPU-bound tasks.
                "recordsWritten": "A String", # Number of records written by the stage.
                "waitRatioMax": 3.14, # Relative amount of time the slowest shard spent waiting to be scheduled.
                "readRatioAvg": 3.14, # Relative amount of time the average shard spent reading input.
                "readRatioMax": 3.14, # Relative amount of time the slowest shard spent reading input.
                "steps": [ # List of operations within the stage in dependency order (approximately chronological).
                  {
                    "kind": "A String", # Machine-readable operation type.
                    "substeps": [ # Human-readable stage descriptions.
                      "A String",
                    ],
                  },
                ],
                "recordsRead": "A String", # Number of records read into the stage.
                "computeRatioAvg": 3.14, # Relative amount of time the average shard spent on CPU-bound tasks.
                "writeRatioMax": 3.14, # Relative amount of time the slowest shard spent on writing output.
                "writeRatioAvg": 3.14, # Relative amount of time the average shard spent on writing output.
                "waitRatioAvg": 3.14, # Relative amount of time the average shard spent waiting to be scheduled.
                "id": "A String", # Unique ID for stage within plan.
                "name": "A String", # Human-readable name for stage.
              },
            ],
            "statementType": "A String", # [Output-only, Experimental] The type of query statement, if valid.
            "totalBytesBilled": "A String", # [Output-only] Total bytes billed for the job.
            "totalBytesProcessed": "A String", # [Output-only] Total bytes processed for the job.
            "cacheHit": True or False, # [Output-only] Whether the query result was fetched from the query cache.
            "undeclaredQueryParameters": [ # [Output-only, Experimental] Standard SQL only: list of undeclared query parameters detected during a dry run validation.
              {
                "parameterType": { # [Required] The type of this parameter.
                  "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                    {
                      "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                      "description": "A String", # [Optional] Human-oriented description of the field.
                      "name": "A String", # [Optional] The name of this field.
                    },
                  ],
                  "type": "A String", # [Required] The top level type of this field.
                  "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                },
                "parameterValue": { # [Required] The value of this parameter.
                  "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                    "a_key": # Object with schema name: QueryParameterValue
                  },
                  "arrayValues": [ # [Optional] The array values, if this is an array type.
                    # Object with schema name: QueryParameterValue
                  ],
                  "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                },
                "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
              },
            ],
            "numDmlAffectedRows": "A String", # [Output-only, Experimental] The number of rows affected by a DML statement. Present only for DML statements INSERT, UPDATE or DELETE.
            "billingTier": 42, # [Output-only] Billing tier for the job.
            "referencedTables": [ # [Output-only, Experimental] Referenced tables for the job. Queries that reference more than 50 tables will not have a complete list.
              {
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
            ],
            "schema": { # [Output-only, Experimental] The schema of the results. Present only for successful dry run of non-legacy SQL queries.
              "fields": [ # Describes the fields in a table.
                {
                  "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                    # Object with schema name: TableFieldSchema
                  ],
                  "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                  "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                  "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                  "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                },
              ],
            },
          },
          "endTime": "A String", # [Output-only] End time of this job, in milliseconds since the epoch. This field will be present whenever a job is in the DONE state.
          "extract": { # [Output-only] Statistics for an extract job.
            "destinationUriFileCounts": [ # [Output-only] Number of files per destination URI or URI pattern specified in the extract configuration. These values will be in the same order as the URIs specified in the 'destinationUris' field.
              "A String",
            ],
          },
        },
        "jobReference": { # [Optional] Reference describing the unique-per-user name of the job.
          "projectId": "A String", # [Required] The ID of the project containing this job.
          "jobId": "A String", # [Required] The ID of the job. The ID must contain only letters (a-z, A-Z), numbers (0-9), underscores (_), or dashes (-). The maximum length is 1,024 characters.
        },
        "etag": "A String", # [Output-only] A hash of this resource.
        "user_email": "A String", # [Output-only] Email address of the user who ran the job.
        "configuration": { # [Required] Describes the job configuration.
          "load": { # [Pick one] Configures a load job.
            "schemaUpdateOptions": [ # [Experimental] Allows the schema of the desitination table to be updated as a side effect of the load job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
              "A String",
            ],
            "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
            "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. The separator can be any ISO-8859-1 single-byte character. To use a character in the range 128-255, you must encode the character as UTF8. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
            "autodetect": True or False, # [Experimental] Indicates if we should automatically infer the options and schema for CSV and JSON sources.
            "sourceFormat": "A String", # [Optional] The format of the data files. For CSV files, specify "CSV". For datastore backups, specify "DATASTORE_BACKUP". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro, specify "AVRO". The default value is CSV.
            "destinationTable": { # [Required] The destination table to load the data into.
              "projectId": "A String", # [Required] The ID of the project containing this table.
              "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
              "datasetId": "A String", # [Required] The ID of the dataset containing this table.
            },
            "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_APPEND. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
            "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when running the job. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid.
            "nullMarker": "A String", # [Optional] This string will be interpreted as a null value when it appears in a CSV file. The default value is the empty string. Please refer to the documentation for further information.
            "allowJaggedRows": True or False, # [Optional] Accept rows that are missing trailing optional columns. The missing values are treated as nulls. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. Only applicable to CSV, ignored for other formats.
            "skipLeadingRows": 42, # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when loading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
            "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud Storage. Each URI can contain one '*' wildcard character and it must come after the 'bucket' name.
              "A String",
            ],
            "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
            "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
            "schemaInlineFormat": "A String", # [Deprecated] The format of the schemaInline property.
            "schemaInline": "A String", # [Deprecated] The inline schema. For CSV schemas, specify as "Field1:Type1[,Field2:Type2]*". For example, "foo:STRING, bar:INTEGER, baz:FLOAT".
            "allowQuotedNewlines": True or False, # Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
            "projectionFields": [ # [Experimental] If sourceFormat is set to "DATASTORE_BACKUP", indicates which entity properties to load into BigQuery from a Cloud Datastore backup. Property names are case sensitive and must be top-level properties. If no properties are specified, BigQuery loads all properties. If any named property isn't found in the Cloud Datastore backup, an invalid error is returned in the job result.
              "A String",
            ],
            "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names
            "schema": { # [Optional] The schema for the destination table. The schema can be omitted if the destination table already exists, or if you're loading data from Google Cloud Datastore.
              "fields": [ # Describes the fields in a table.
                {
                  "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                    # Object with schema name: TableFieldSchema
                  ],
                  "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                  "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                  "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                  "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                },
              ],
            },
          },
          "dryRun": True or False, # [Optional] If set, don't actually run this job. A valid query will return a mostly empty response with some processing statistics, while an invalid query will return the same error it would if it wasn't a dry run. Behavior of non-query jobs is undefined.
          "labels": { # [Experimental] The labels associated with this job. You can use these to organize and group your jobs. Label keys and values can be no longer than 63 characters, can only contain letters, numeric characters, underscores and dashes. International characters are allowed. Label values are optional. Label keys must start with a letter and must be unique within a dataset. Both keys and values are additionally constrained to be <= 128 bytes in size.
            "a_key": "A String",
          },
          "query": { # [Pick one] Configures a query job.
            "flattenResults": true, # [Optional] Flattens all nested and repeated fields in the query results. The default value is true. allowLargeResults must be true if this is set to false.
            "maximumBillingTier": 1, # [Optional] Limits the billing tier for this job. Queries that have resource usage beyond this tier will fail (without incurring a charge). If unspecified, this will be set to your project default.
            "useQueryCache": true, # [Optional] Whether to look for the result in the query cache. The query cache is a best-effort cache that will be flushed whenever tables in the query are modified. Moreover, the query cache is only available when a query does not have a destination table specified. The default value is true.
            "defaultDataset": { # [Optional] Specifies the default dataset to use for unqualified table names in the query.
              "projectId": "A String", # [Optional] The ID of the project containing this dataset.
              "datasetId": "A String", # [Required] A unique ID for this dataset, without the project name. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
            },
            "useLegacySql": True or False, # Specifies whether to use BigQuery's legacy SQL dialect for this query. The default value is true. If set to false, the query will use BigQuery's standard SQL: https://cloud.google.com/bigquery/sql-reference/ When useLegacySql is set to false, the values of allowLargeResults and flattenResults are ignored; query will be run as if allowLargeResults is true and flattenResults is false.
            "destinationTable": { # [Optional] Describes the table where the query results should be stored. If not present, a new table will be created to store the results.
              "projectId": "A String", # [Required] The ID of the project containing this table.
              "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
              "datasetId": "A String", # [Required] The ID of the dataset containing this table.
            },
            "schemaUpdateOptions": [ # [Experimental] Allows the schema of the destination table to be updated as a side effect of the query job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
              "A String",
            ],
            "priority": "A String", # [Optional] Specifies a priority for the query. Possible values include INTERACTIVE and BATCH. The default value is INTERACTIVE.
            "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
            "allowLargeResults": True or False, # If true, allows the query to produce arbitrarily large result tables at a slight cost in performance. Requires destinationTable to be set.
            "userDefinedFunctionResources": [ # [Experimental] Describes user-defined function resources used in the query.
              {
                "resourceUri": "A String", # [Pick one] A code resource to load from a Google Cloud Storage URI (gs://bucket/path).
                "inlineCode": "A String", # [Pick one] An inline resource that contains code for a user-defined function (UDF). Providing a inline code resource is equivalent to providing a URI for a file containing the same code.
              },
            ],
            "queryParameters": [ # Query parameters for standard SQL queries.
              {
                "parameterType": { # [Required] The type of this parameter.
                  "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                    {
                      "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                      "description": "A String", # [Optional] Human-oriented description of the field.
                      "name": "A String", # [Optional] The name of this field.
                    },
                  ],
                  "type": "A String", # [Required] The top level type of this field.
                  "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                },
                "parameterValue": { # [Required] The value of this parameter.
                  "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                    "a_key": # Object with schema name: QueryParameterValue
                  },
                  "arrayValues": [ # [Optional] The array values, if this is an array type.
                    # Object with schema name: QueryParameterValue
                  ],
                  "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                },
                "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
              },
            ],
            "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
            "query": "A String", # [Required] BigQuery SQL query to execute.
            "preserveNulls": True or False, # [Deprecated] This property is deprecated.
            "maximumBytesBilled": "A String", # [Optional] Limits the bytes billed for this job. Queries that will have bytes billed beyond this limit will fail (without incurring a charge). If unspecified, this will be set to your project default.
            "tableDefinitions": { # [Optional] If querying an external data source outside of BigQuery, describes the data format, location and other properties of the data source. By defining these properties, the data source can then be queried as if it were a standard BigQuery table.
              "a_key": {
                "compression": "A String", # [Optional] The compression type of the data source. Possible values include GZIP and NONE. The default value is NONE. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                "csvOptions": { # Additional properties to set if sourceFormat is set to CSV.
                  "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
                  "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
                  "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
                  "allowJaggedRows": True or False, # [Optional] Indicates if BigQuery should accept rows that are missing trailing optional columns. If true, BigQuery treats missing trailing columns as null values. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false.
                  "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
                  "allowQuotedNewlines": True or False, # [Optional] Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
                },
                "autodetect": True or False, # [Experimental] Try to detect schema and format options automatically. Any option specified explicitly will be honored.
                "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when reading data. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names Google Cloud Bigtable: This setting is ignored. Google Cloud Datastore backups: This setting is ignored. Avro: This setting is ignored.
                "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud. For Google Cloud Storage URIs: Each URI can contain one '*' wildcard character and it must come after the 'bucket' name. Size limits related to load jobs apply to external data sources. For Google Cloud Bigtable URIs: Exactly one URI can be specified and it has be a fully specified and valid HTTPS URL for a Google Cloud Bigtable table. For Google Cloud Datastore backups, exactly one URI can be specified, and it must end with '.backup_info'. Also, the '*' wildcard character is not allowed.
                  "A String",
                ],
                "bigtableOptions": { # [Optional] Additional options if sourceFormat is set to BIGTABLE.
                  "readRowkeyAsString": True or False, # [Optional] If field is true, then the rowkey column families will be read and converted to string. Otherwise they are read with BYTES type values and users need to manually cast them with CAST if necessary. The default value is false.
                  "ignoreUnspecifiedColumnFamilies": True or False, # [Optional] If field is true, then the column families that are not specified in columnFamilies list are not exposed in the table schema. Otherwise, they are read with BYTES type values. The default value is false.
                  "columnFamilies": [ # [Optional] List of column families to expose in the table schema along with their types. This list restricts the column families that can be referenced in queries and specifies their value types. You can use this list to do type conversions - see the 'type' field for more details. If you leave this list empty, all column families are present in the table schema and their values are read as BYTES. During a query only the column families referenced in that query are read from Bigtable.
                    {
                      "familyId": "A String", # Identifier of the column family.
                      "type": "A String", # [Optional] The type to convert the value in cells of this column family. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. This can be overridden for a specific column by listing that column in 'columns' and specifying a type for it.
                      "onlyReadLatest": True or False, # [Optional] If this is set only the latest version of value are exposed for all columns in this column family. This can be overridden for a specific column by listing that column in 'columns' and specifying a different setting for that column.
                      "columns": [ # [Optional] Lists of columns that should be exposed as individual fields as opposed to a list of (column name, value) pairs. All columns whose qualifier matches a qualifier in this list can be accessed as .. Other columns can be accessed as a list through .Column field.
                        {
                          "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. 'encoding' can also be set at the column family level. However, the setting at this level takes precedence if 'encoding' is set at both levels.
                          "qualifierEncoded": "A String", # [Required] Qualifier of the column. Columns in the parent column family that has this exact qualifier are exposed as . field. If the qualifier is valid UTF-8 string, it can be specified in the qualifier_string field. Otherwise, a base-64 encoded value must be set to qualifier_encoded. The column field name is the same as the column qualifier. However, if the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as field_name.
                          "fieldName": "A String", # [Optional] If the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as the column field name and is used as field name in queries.
                          "onlyReadLatest": True or False, # [Optional] If this is set, only the latest version of value in this column are exposed. 'onlyReadLatest' can also be set at the column family level. However, the setting at this level takes precedence if 'onlyReadLatest' is set at both levels.
                          "qualifierString": "A String",
                          "type": "A String", # [Optional] The type to convert the value in cells of this column. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. 'type' can also be set at the column family level. However, the setting at this level takes precedence if 'type' is set at both levels.
                        },
                      ],
                      "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. This can be overridden for a specific column by listing that column in 'columns' and specifying an encoding for it.
                    },
                  ],
                },
                "sourceFormat": "A String", # [Required] The data format. For CSV files, specify "CSV". For Google sheets, specify "GOOGLE_SHEETS". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro files, specify "AVRO". For Google Cloud Datastore backups, specify "DATASTORE_BACKUP". [Experimental] For Google Cloud Bigtable, specify "BIGTABLE". Please note that reading from Google Cloud Bigtable is experimental and has to be enabled for your project. Please contact Google Cloud Support to enable this for your project.
                "googleSheetsOptions": { # [Optional] Additional options if sourceFormat is set to GOOGLE_SHEETS.
                  "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a sheet that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows that should be skipped. When autodetect is on, behavior is the following: * skipLeadingRows unspecified - Autodetect tries to detect headers in the first row. If they are not detected, the row is read as data. Otherwise data is read starting from the second row. * skipLeadingRows is 0 - Instructs autodetect that there are no headers and data should be read starting from the first row. * skipLeadingRows = N > 0 - Autodetect skips N-1 rows and tries to detect headers in row N. If headers are not detected, row N is just skipped. Otherwise row N is used to extract column names for the detected schema.
                },
                "schema": { # [Optional] The schema for the data. Schema is required for CSV and JSON formats. Schema is disallowed for Google Cloud Bigtable, Cloud Datastore backups, and Avro formats.
                  "fields": [ # Describes the fields in a table.
                    {
                      "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                        # Object with schema name: TableFieldSchema
                      ],
                      "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                      "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                      "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                      "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                    },
                  ],
                },
              },
            },
            "parameterMode": "A String", # [Experimental] Standard SQL only. Whether to use positional (?) or named (@myparam) query parameters in this query.
          },
          "copy": { # [Pick one] Copies a table.
            "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
            "sourceTables": [ # [Pick one] Source tables to copy.
              {
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
            ],
            "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
            "destinationTable": { # [Required] The destination table
              "projectId": "A String", # [Required] The ID of the project containing this table.
              "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
              "datasetId": "A String", # [Required] The ID of the dataset containing this table.
            },
            "sourceTable": { # [Pick one] Source table to copy.
              "projectId": "A String", # [Required] The ID of the project containing this table.
              "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
              "datasetId": "A String", # [Required] The ID of the dataset containing this table.
            },
          },
          "extract": { # [Pick one] Configures an extract job.
            "destinationUri": "A String", # [Pick one] DEPRECATED: Use destinationUris instead, passing only one URI as necessary. The fully-qualified Google Cloud Storage URI where the extracted table should be written.
            "compression": "A String", # [Optional] The compression type to use for exported files. Possible values include GZIP and NONE. The default value is NONE.
            "fieldDelimiter": "A String", # [Optional] Delimiter to use between fields in the exported data. Default is ','
            "destinationFormat": "A String", # [Optional] The exported file format. Possible values include CSV, NEWLINE_DELIMITED_JSON and AVRO. The default value is CSV. Tables with nested or repeated fields cannot be exported as CSV.
            "printHeader": true, # [Optional] Whether to print out a header row in the results. Default is true.
            "destinationUris": [ # [Pick one] A list of fully-qualified Google Cloud Storage URIs where the extracted table should be written.
              "A String",
            ],
            "sourceTable": { # [Required] A reference to the table being exported.
              "projectId": "A String", # [Required] The ID of the project containing this table.
              "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
              "datasetId": "A String", # [Required] The ID of the dataset containing this table.
            },
          },
        },
        "id": "A String", # [Output-only] Opaque ID field of the job
        "selfLink": "A String", # [Output-only] A URL that can be used to access this resource again.
      }

      media_body: string, The filename of the media request body, or an instance of a MediaUpload object.
      media_mime_type: string, The MIME type of the media request body, or an instance of a MediaUpload object.

    Returns:
      An object of the form:

        {
          "status": { # [Output-only] The status of this job. Examine this value when polling an asynchronous job to see if the job is complete.
            "state": "A String", # [Output-only] Running state of the job.
            "errors": [ # [Output-only] All errors encountered during the running of the job. Errors here do not necessarily mean that the job has completed or was unsuccessful.
              {
                "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
                "message": "A String", # A human-readable description of the error.
                "reason": "A String", # A short error code that summarizes the error.
                "location": "A String", # Specifies where the error occurred, if present.
              },
            ],
            "errorResult": { # [Output-only] Final error result of the job. If present, indicates that the job has completed and was unsuccessful.
              "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
              "message": "A String", # A human-readable description of the error.
              "reason": "A String", # A short error code that summarizes the error.
              "location": "A String", # Specifies where the error occurred, if present.
            },
          },
          "kind": "bigquery#job", # [Output-only] The type of the resource.
          "statistics": { # [Output-only] Information about the job, including starting time and ending time of the job.
            "load": { # [Output-only] Statistics for a load job.
              "outputRows": "A String", # [Output-only] Number of rows imported in a load job. Note that while an import job is in the running state, this value may change.
              "inputFiles": "A String", # [Output-only] Number of source files in a load job.
              "inputFileBytes": "A String", # [Output-only] Number of bytes of source data in a load job.
              "outputBytes": "A String", # [Output-only] Size of the loaded data in bytes. Note that while a load job is in the running state, this value may change.
            },
            "creationTime": "A String", # [Output-only] Creation time of this job, in milliseconds since the epoch. This field will be present on all jobs.
            "totalBytesProcessed": "A String", # [Output-only] [Deprecated] Use the bytes processed in the query statistics instead.
            "startTime": "A String", # [Output-only] Start time of this job, in milliseconds since the epoch. This field will be present when the job transitions from the PENDING state to either RUNNING or DONE.
            "query": { # [Output-only] Statistics for a query job.
              "queryPlan": [ # [Output-only, Experimental] Describes execution plan for the query.
                {
                  "computeRatioMax": 3.14, # Relative amount of time the slowest shard spent on CPU-bound tasks.
                  "recordsWritten": "A String", # Number of records written by the stage.
                  "waitRatioMax": 3.14, # Relative amount of time the slowest shard spent waiting to be scheduled.
                  "readRatioAvg": 3.14, # Relative amount of time the average shard spent reading input.
                  "readRatioMax": 3.14, # Relative amount of time the slowest shard spent reading input.
                  "steps": [ # List of operations within the stage in dependency order (approximately chronological).
                    {
                      "kind": "A String", # Machine-readable operation type.
                      "substeps": [ # Human-readable stage descriptions.
                        "A String",
                      ],
                    },
                  ],
                  "recordsRead": "A String", # Number of records read into the stage.
                  "computeRatioAvg": 3.14, # Relative amount of time the average shard spent on CPU-bound tasks.
                  "writeRatioMax": 3.14, # Relative amount of time the slowest shard spent on writing output.
                  "writeRatioAvg": 3.14, # Relative amount of time the average shard spent on writing output.
                  "waitRatioAvg": 3.14, # Relative amount of time the average shard spent waiting to be scheduled.
                  "id": "A String", # Unique ID for stage within plan.
                  "name": "A String", # Human-readable name for stage.
                },
              ],
              "statementType": "A String", # [Output-only, Experimental] The type of query statement, if valid.
              "totalBytesBilled": "A String", # [Output-only] Total bytes billed for the job.
              "totalBytesProcessed": "A String", # [Output-only] Total bytes processed for the job.
              "cacheHit": True or False, # [Output-only] Whether the query result was fetched from the query cache.
              "undeclaredQueryParameters": [ # [Output-only, Experimental] Standard SQL only: list of undeclared query parameters detected during a dry run validation.
                {
                  "parameterType": { # [Required] The type of this parameter.
                    "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                      {
                        "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                        "description": "A String", # [Optional] Human-oriented description of the field.
                        "name": "A String", # [Optional] The name of this field.
                      },
                    ],
                    "type": "A String", # [Required] The top level type of this field.
                    "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                  },
                  "parameterValue": { # [Required] The value of this parameter.
                    "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                      "a_key": # Object with schema name: QueryParameterValue
                    },
                    "arrayValues": [ # [Optional] The array values, if this is an array type.
                      # Object with schema name: QueryParameterValue
                    ],
                    "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                  },
                  "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
                },
              ],
              "numDmlAffectedRows": "A String", # [Output-only, Experimental] The number of rows affected by a DML statement. Present only for DML statements INSERT, UPDATE or DELETE.
              "billingTier": 42, # [Output-only] Billing tier for the job.
              "referencedTables": [ # [Output-only, Experimental] Referenced tables for the job. Queries that reference more than 50 tables will not have a complete list.
                {
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
              ],
              "schema": { # [Output-only, Experimental] The schema of the results. Present only for successful dry run of non-legacy SQL queries.
                "fields": [ # Describes the fields in a table.
                  {
                    "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                      # Object with schema name: TableFieldSchema
                    ],
                    "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                    "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                    "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                    "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                  },
                ],
              },
            },
            "endTime": "A String", # [Output-only] End time of this job, in milliseconds since the epoch. This field will be present whenever a job is in the DONE state.
            "extract": { # [Output-only] Statistics for an extract job.
              "destinationUriFileCounts": [ # [Output-only] Number of files per destination URI or URI pattern specified in the extract configuration. These values will be in the same order as the URIs specified in the 'destinationUris' field.
                "A String",
              ],
            },
          },
          "jobReference": { # [Optional] Reference describing the unique-per-user name of the job.
            "projectId": "A String", # [Required] The ID of the project containing this job.
            "jobId": "A String", # [Required] The ID of the job. The ID must contain only letters (a-z, A-Z), numbers (0-9), underscores (_), or dashes (-). The maximum length is 1,024 characters.
          },
          "etag": "A String", # [Output-only] A hash of this resource.
          "user_email": "A String", # [Output-only] Email address of the user who ran the job.
          "configuration": { # [Required] Describes the job configuration.
            "load": { # [Pick one] Configures a load job.
              "schemaUpdateOptions": [ # [Experimental] Allows the schema of the desitination table to be updated as a side effect of the load job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
                "A String",
              ],
              "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
              "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. The separator can be any ISO-8859-1 single-byte character. To use a character in the range 128-255, you must encode the character as UTF8. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
              "autodetect": True or False, # [Experimental] Indicates if we should automatically infer the options and schema for CSV and JSON sources.
              "sourceFormat": "A String", # [Optional] The format of the data files. For CSV files, specify "CSV". For datastore backups, specify "DATASTORE_BACKUP". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro, specify "AVRO". The default value is CSV.
              "destinationTable": { # [Required] The destination table to load the data into.
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
              "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_APPEND. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
              "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when running the job. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid.
              "nullMarker": "A String", # [Optional] This string will be interpreted as a null value when it appears in a CSV file. The default value is the empty string. Please refer to the documentation for further information.
              "allowJaggedRows": True or False, # [Optional] Accept rows that are missing trailing optional columns. The missing values are treated as nulls. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. Only applicable to CSV, ignored for other formats.
              "skipLeadingRows": 42, # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when loading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
              "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud Storage. Each URI can contain one '*' wildcard character and it must come after the 'bucket' name.
                "A String",
              ],
              "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
              "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
              "schemaInlineFormat": "A String", # [Deprecated] The format of the schemaInline property.
              "schemaInline": "A String", # [Deprecated] The inline schema. For CSV schemas, specify as "Field1:Type1[,Field2:Type2]*". For example, "foo:STRING, bar:INTEGER, baz:FLOAT".
              "allowQuotedNewlines": True or False, # Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
              "projectionFields": [ # [Experimental] If sourceFormat is set to "DATASTORE_BACKUP", indicates which entity properties to load into BigQuery from a Cloud Datastore backup. Property names are case sensitive and must be top-level properties. If no properties are specified, BigQuery loads all properties. If any named property isn't found in the Cloud Datastore backup, an invalid error is returned in the job result.
                "A String",
              ],
              "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names
              "schema": { # [Optional] The schema for the destination table. The schema can be omitted if the destination table already exists, or if you're loading data from Google Cloud Datastore.
                "fields": [ # Describes the fields in a table.
                  {
                    "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                      # Object with schema name: TableFieldSchema
                    ],
                    "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                    "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                    "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                    "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                  },
                ],
              },
            },
            "dryRun": True or False, # [Optional] If set, don't actually run this job. A valid query will return a mostly empty response with some processing statistics, while an invalid query will return the same error it would if it wasn't a dry run. Behavior of non-query jobs is undefined.
            "labels": { # [Experimental] The labels associated with this job. You can use these to organize and group your jobs. Label keys and values can be no longer than 63 characters, can only contain letters, numeric characters, underscores and dashes. International characters are allowed. Label values are optional. Label keys must start with a letter and must be unique within a dataset. Both keys and values are additionally constrained to be <= 128 bytes in size.
              "a_key": "A String",
            },
            "query": { # [Pick one] Configures a query job.
              "flattenResults": true, # [Optional] Flattens all nested and repeated fields in the query results. The default value is true. allowLargeResults must be true if this is set to false.
              "maximumBillingTier": 1, # [Optional] Limits the billing tier for this job. Queries that have resource usage beyond this tier will fail (without incurring a charge). If unspecified, this will be set to your project default.
              "useQueryCache": true, # [Optional] Whether to look for the result in the query cache. The query cache is a best-effort cache that will be flushed whenever tables in the query are modified. Moreover, the query cache is only available when a query does not have a destination table specified. The default value is true.
              "defaultDataset": { # [Optional] Specifies the default dataset to use for unqualified table names in the query.
                "projectId": "A String", # [Optional] The ID of the project containing this dataset.
                "datasetId": "A String", # [Required] A unique ID for this dataset, without the project name. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
              },
              "useLegacySql": True or False, # Specifies whether to use BigQuery's legacy SQL dialect for this query. The default value is true. If set to false, the query will use BigQuery's standard SQL: https://cloud.google.com/bigquery/sql-reference/ When useLegacySql is set to false, the values of allowLargeResults and flattenResults are ignored; query will be run as if allowLargeResults is true and flattenResults is false.
              "destinationTable": { # [Optional] Describes the table where the query results should be stored. If not present, a new table will be created to store the results.
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
              "schemaUpdateOptions": [ # [Experimental] Allows the schema of the destination table to be updated as a side effect of the query job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
                "A String",
              ],
              "priority": "A String", # [Optional] Specifies a priority for the query. Possible values include INTERACTIVE and BATCH. The default value is INTERACTIVE.
              "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
              "allowLargeResults": True or False, # If true, allows the query to produce arbitrarily large result tables at a slight cost in performance. Requires destinationTable to be set.
              "userDefinedFunctionResources": [ # [Experimental] Describes user-defined function resources used in the query.
                {
                  "resourceUri": "A String", # [Pick one] A code resource to load from a Google Cloud Storage URI (gs://bucket/path).
                  "inlineCode": "A String", # [Pick one] An inline resource that contains code for a user-defined function (UDF). Providing a inline code resource is equivalent to providing a URI for a file containing the same code.
                },
              ],
              "queryParameters": [ # Query parameters for standard SQL queries.
                {
                  "parameterType": { # [Required] The type of this parameter.
                    "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                      {
                        "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                        "description": "A String", # [Optional] Human-oriented description of the field.
                        "name": "A String", # [Optional] The name of this field.
                      },
                    ],
                    "type": "A String", # [Required] The top level type of this field.
                    "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                  },
                  "parameterValue": { # [Required] The value of this parameter.
                    "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                      "a_key": # Object with schema name: QueryParameterValue
                    },
                    "arrayValues": [ # [Optional] The array values, if this is an array type.
                      # Object with schema name: QueryParameterValue
                    ],
                    "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                  },
                  "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
                },
              ],
              "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
              "query": "A String", # [Required] BigQuery SQL query to execute.
              "preserveNulls": True or False, # [Deprecated] This property is deprecated.
              "maximumBytesBilled": "A String", # [Optional] Limits the bytes billed for this job. Queries that will have bytes billed beyond this limit will fail (without incurring a charge). If unspecified, this will be set to your project default.
              "tableDefinitions": { # [Optional] If querying an external data source outside of BigQuery, describes the data format, location and other properties of the data source. By defining these properties, the data source can then be queried as if it were a standard BigQuery table.
                "a_key": {
                  "compression": "A String", # [Optional] The compression type of the data source. Possible values include GZIP and NONE. The default value is NONE. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                  "csvOptions": { # Additional properties to set if sourceFormat is set to CSV.
                    "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
                    "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
                    "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
                    "allowJaggedRows": True or False, # [Optional] Indicates if BigQuery should accept rows that are missing trailing optional columns. If true, BigQuery treats missing trailing columns as null values. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false.
                    "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
                    "allowQuotedNewlines": True or False, # [Optional] Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
                  },
                  "autodetect": True or False, # [Experimental] Try to detect schema and format options automatically. Any option specified explicitly will be honored.
                  "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when reading data. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                  "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names Google Cloud Bigtable: This setting is ignored. Google Cloud Datastore backups: This setting is ignored. Avro: This setting is ignored.
                  "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud. For Google Cloud Storage URIs: Each URI can contain one '*' wildcard character and it must come after the 'bucket' name. Size limits related to load jobs apply to external data sources. For Google Cloud Bigtable URIs: Exactly one URI can be specified and it has be a fully specified and valid HTTPS URL for a Google Cloud Bigtable table. For Google Cloud Datastore backups, exactly one URI can be specified, and it must end with '.backup_info'. Also, the '*' wildcard character is not allowed.
                    "A String",
                  ],
                  "bigtableOptions": { # [Optional] Additional options if sourceFormat is set to BIGTABLE.
                    "readRowkeyAsString": True or False, # [Optional] If field is true, then the rowkey column families will be read and converted to string. Otherwise they are read with BYTES type values and users need to manually cast them with CAST if necessary. The default value is false.
                    "ignoreUnspecifiedColumnFamilies": True or False, # [Optional] If field is true, then the column families that are not specified in columnFamilies list are not exposed in the table schema. Otherwise, they are read with BYTES type values. The default value is false.
                    "columnFamilies": [ # [Optional] List of column families to expose in the table schema along with their types. This list restricts the column families that can be referenced in queries and specifies their value types. You can use this list to do type conversions - see the 'type' field for more details. If you leave this list empty, all column families are present in the table schema and their values are read as BYTES. During a query only the column families referenced in that query are read from Bigtable.
                      {
                        "familyId": "A String", # Identifier of the column family.
                        "type": "A String", # [Optional] The type to convert the value in cells of this column family. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. This can be overridden for a specific column by listing that column in 'columns' and specifying a type for it.
                        "onlyReadLatest": True or False, # [Optional] If this is set only the latest version of value are exposed for all columns in this column family. This can be overridden for a specific column by listing that column in 'columns' and specifying a different setting for that column.
                        "columns": [ # [Optional] Lists of columns that should be exposed as individual fields as opposed to a list of (column name, value) pairs. All columns whose qualifier matches a qualifier in this list can be accessed as .. Other columns can be accessed as a list through .Column field.
                          {
                            "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. 'encoding' can also be set at the column family level. However, the setting at this level takes precedence if 'encoding' is set at both levels.
                            "qualifierEncoded": "A String", # [Required] Qualifier of the column. Columns in the parent column family that has this exact qualifier are exposed as . field. If the qualifier is valid UTF-8 string, it can be specified in the qualifier_string field. Otherwise, a base-64 encoded value must be set to qualifier_encoded. The column field name is the same as the column qualifier. However, if the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as field_name.
                            "fieldName": "A String", # [Optional] If the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as the column field name and is used as field name in queries.
                            "onlyReadLatest": True or False, # [Optional] If this is set, only the latest version of value in this column are exposed. 'onlyReadLatest' can also be set at the column family level. However, the setting at this level takes precedence if 'onlyReadLatest' is set at both levels.
                            "qualifierString": "A String",
                            "type": "A String", # [Optional] The type to convert the value in cells of this column. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. 'type' can also be set at the column family level. However, the setting at this level takes precedence if 'type' is set at both levels.
                          },
                        ],
                        "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. This can be overridden for a specific column by listing that column in 'columns' and specifying an encoding for it.
                      },
                    ],
                  },
                  "sourceFormat": "A String", # [Required] The data format. For CSV files, specify "CSV". For Google sheets, specify "GOOGLE_SHEETS". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro files, specify "AVRO". For Google Cloud Datastore backups, specify "DATASTORE_BACKUP". [Experimental] For Google Cloud Bigtable, specify "BIGTABLE". Please note that reading from Google Cloud Bigtable is experimental and has to be enabled for your project. Please contact Google Cloud Support to enable this for your project.
                  "googleSheetsOptions": { # [Optional] Additional options if sourceFormat is set to GOOGLE_SHEETS.
                    "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a sheet that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows that should be skipped. When autodetect is on, behavior is the following: * skipLeadingRows unspecified - Autodetect tries to detect headers in the first row. If they are not detected, the row is read as data. Otherwise data is read starting from the second row. * skipLeadingRows is 0 - Instructs autodetect that there are no headers and data should be read starting from the first row. * skipLeadingRows = N > 0 - Autodetect skips N-1 rows and tries to detect headers in row N. If headers are not detected, row N is just skipped. Otherwise row N is used to extract column names for the detected schema.
                  },
                  "schema": { # [Optional] The schema for the data. Schema is required for CSV and JSON formats. Schema is disallowed for Google Cloud Bigtable, Cloud Datastore backups, and Avro formats.
                    "fields": [ # Describes the fields in a table.
                      {
                        "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                          # Object with schema name: TableFieldSchema
                        ],
                        "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                        "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                        "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                        "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                      },
                    ],
                  },
                },
              },
              "parameterMode": "A String", # [Experimental] Standard SQL only. Whether to use positional (?) or named (@myparam) query parameters in this query.
            },
            "copy": { # [Pick one] Copies a table.
              "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
              "sourceTables": [ # [Pick one] Source tables to copy.
                {
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
              ],
              "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
              "destinationTable": { # [Required] The destination table
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
              "sourceTable": { # [Pick one] Source table to copy.
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
            },
            "extract": { # [Pick one] Configures an extract job.
              "destinationUri": "A String", # [Pick one] DEPRECATED: Use destinationUris instead, passing only one URI as necessary. The fully-qualified Google Cloud Storage URI where the extracted table should be written.
              "compression": "A String", # [Optional] The compression type to use for exported files. Possible values include GZIP and NONE. The default value is NONE.
              "fieldDelimiter": "A String", # [Optional] Delimiter to use between fields in the exported data. Default is ','
              "destinationFormat": "A String", # [Optional] The exported file format. Possible values include CSV, NEWLINE_DELIMITED_JSON and AVRO. The default value is CSV. Tables with nested or repeated fields cannot be exported as CSV.
              "printHeader": true, # [Optional] Whether to print out a header row in the results. Default is true.
              "destinationUris": [ # [Pick one] A list of fully-qualified Google Cloud Storage URIs where the extracted table should be written.
                "A String",
              ],
              "sourceTable": { # [Required] A reference to the table being exported.
                "projectId": "A String", # [Required] The ID of the project containing this table.
                "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                "datasetId": "A String", # [Required] The ID of the dataset containing this table.
              },
            },
          },
          "id": "A String", # [Output-only] Opaque ID field of the job
          "selfLink": "A String", # [Output-only] A URL that can be used to access this resource again.
        }

`list(projectId, projection=None, stateFilter=None, pageToken=None, allUsers=None, maxResults=None)`

    Lists all jobs that you started in the specified project. Job information is available for a six month period after creation. The job list is sorted in reverse chronological order, by job creation time. Requires the Can View project role, or the Is Owner project role if you set the allUsers property.

    Args:
      projectId: string, Project ID of the jobs to list (required)
      projection: string, Restrict information returned to a set of selected fields
        Allowed values
          full - Includes all job data
          minimal - Does not include the job configuration
      stateFilter: string, Filter for job state (repeated)
        Allowed values
          done - Finished jobs
          pending - Pending jobs
          running - Running jobs
      pageToken: string, Page token, returned by a previous call, to request the next page of results
      allUsers: boolean, Whether to display jobs owned by all users in the project. Default false
      maxResults: integer, Maximum number of results to return

    Returns:
      An object of the form:

        {
        "nextPageToken": "A String", # A token to request the next page of results.
        "kind": "bigquery#jobList", # The resource type of the response.
        "etag": "A String", # A hash of this page of results.
        "jobs": [ # List of jobs that were requested.
          {
            "status": { # [Full-projection-only] Describes the state of the job.
              "state": "A String", # [Output-only] Running state of the job.
              "errors": [ # [Output-only] All errors encountered during the running of the job. Errors here do not necessarily mean that the job has completed or was unsuccessful.
                {
                  "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
                  "message": "A String", # A human-readable description of the error.
                  "reason": "A String", # A short error code that summarizes the error.
                  "location": "A String", # Specifies where the error occurred, if present.
                },
              ],
              "errorResult": { # [Output-only] Final error result of the job. If present, indicates that the job has completed and was unsuccessful.
                "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
                "message": "A String", # A human-readable description of the error.
                "reason": "A String", # A short error code that summarizes the error.
                "location": "A String", # Specifies where the error occurred, if present.
              },
            },
            "kind": "bigquery#job", # The resource type.
            "statistics": { # [Output-only] Information about the job, including starting time and ending time of the job.
              "load": { # [Output-only] Statistics for a load job.
                "outputRows": "A String", # [Output-only] Number of rows imported in a load job. Note that while an import job is in the running state, this value may change.
                "inputFiles": "A String", # [Output-only] Number of source files in a load job.
                "inputFileBytes": "A String", # [Output-only] Number of bytes of source data in a load job.
                "outputBytes": "A String", # [Output-only] Size of the loaded data in bytes. Note that while a load job is in the running state, this value may change.
              },
              "creationTime": "A String", # [Output-only] Creation time of this job, in milliseconds since the epoch. This field will be present on all jobs.
              "totalBytesProcessed": "A String", # [Output-only] [Deprecated] Use the bytes processed in the query statistics instead.
              "startTime": "A String", # [Output-only] Start time of this job, in milliseconds since the epoch. This field will be present when the job transitions from the PENDING state to either RUNNING or DONE.
              "query": { # [Output-only] Statistics for a query job.
                "queryPlan": [ # [Output-only, Experimental] Describes execution plan for the query.
                  {
                    "computeRatioMax": 3.14, # Relative amount of time the slowest shard spent on CPU-bound tasks.
                    "recordsWritten": "A String", # Number of records written by the stage.
                    "waitRatioMax": 3.14, # Relative amount of time the slowest shard spent waiting to be scheduled.
                    "readRatioAvg": 3.14, # Relative amount of time the average shard spent reading input.
                    "readRatioMax": 3.14, # Relative amount of time the slowest shard spent reading input.
                    "steps": [ # List of operations within the stage in dependency order (approximately chronological).
                      {
                        "kind": "A String", # Machine-readable operation type.
                        "substeps": [ # Human-readable stage descriptions.
                          "A String",
                        ],
                      },
                    ],
                    "recordsRead": "A String", # Number of records read into the stage.
                    "computeRatioAvg": 3.14, # Relative amount of time the average shard spent on CPU-bound tasks.
                    "writeRatioMax": 3.14, # Relative amount of time the slowest shard spent on writing output.
                    "writeRatioAvg": 3.14, # Relative amount of time the average shard spent on writing output.
                    "waitRatioAvg": 3.14, # Relative amount of time the average shard spent waiting to be scheduled.
                    "id": "A String", # Unique ID for stage within plan.
                    "name": "A String", # Human-readable name for stage.
                  },
                ],
                "statementType": "A String", # [Output-only, Experimental] The type of query statement, if valid.
                "totalBytesBilled": "A String", # [Output-only] Total bytes billed for the job.
                "totalBytesProcessed": "A String", # [Output-only] Total bytes processed for the job.
                "cacheHit": True or False, # [Output-only] Whether the query result was fetched from the query cache.
                "undeclaredQueryParameters": [ # [Output-only, Experimental] Standard SQL only: list of undeclared query parameters detected during a dry run validation.
                  {
                    "parameterType": { # [Required] The type of this parameter.
                      "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                        {
                          "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                          "description": "A String", # [Optional] Human-oriented description of the field.
                          "name": "A String", # [Optional] The name of this field.
                        },
                      ],
                      "type": "A String", # [Required] The top level type of this field.
                      "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                    },
                    "parameterValue": { # [Required] The value of this parameter.
                      "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                        "a_key": # Object with schema name: QueryParameterValue
                      },
                      "arrayValues": [ # [Optional] The array values, if this is an array type.
                        # Object with schema name: QueryParameterValue
                      ],
                      "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                    },
                    "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
                  },
                ],
                "numDmlAffectedRows": "A String", # [Output-only, Experimental] The number of rows affected by a DML statement. Present only for DML statements INSERT, UPDATE or DELETE.
                "billingTier": 42, # [Output-only] Billing tier for the job.
                "referencedTables": [ # [Output-only, Experimental] Referenced tables for the job. Queries that reference more than 50 tables will not have a complete list.
                  {
                    "projectId": "A String", # [Required] The ID of the project containing this table.
                    "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                    "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                  },
                ],
                "schema": { # [Output-only, Experimental] The schema of the results. Present only for successful dry run of non-legacy SQL queries.
                  "fields": [ # Describes the fields in a table.
                    {
                      "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                        # Object with schema name: TableFieldSchema
                      ],
                      "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                      "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                      "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                      "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                    },
                  ],
                },
              },
              "endTime": "A String", # [Output-only] End time of this job, in milliseconds since the epoch. This field will be present whenever a job is in the DONE state.
              "extract": { # [Output-only] Statistics for an extract job.
                "destinationUriFileCounts": [ # [Output-only] Number of files per destination URI or URI pattern specified in the extract configuration. These values will be in the same order as the URIs specified in the 'destinationUris' field.
                  "A String",
                ],
              },
            },
            "jobReference": { # Job reference uniquely identifying the job.
              "projectId": "A String", # [Required] The ID of the project containing this job.
              "jobId": "A String", # [Required] The ID of the job. The ID must contain only letters (a-z, A-Z), numbers (0-9), underscores (_), or dashes (-). The maximum length is 1,024 characters.
            },
            "state": "A String", # Running state of the job. When the state is DONE, errorResult can be checked to determine whether the job succeeded or failed.
            "user_email": "A String", # [Full-projection-only] Email address of the user who ran the job.
            "configuration": { # [Full-projection-only] Specifies the job configuration.
              "load": { # [Pick one] Configures a load job.
                "schemaUpdateOptions": [ # [Experimental] Allows the schema of the desitination table to be updated as a side effect of the load job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
                  "A String",
                ],
                "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
                "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. The separator can be any ISO-8859-1 single-byte character. To use a character in the range 128-255, you must encode the character as UTF8. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
                "autodetect": True or False, # [Experimental] Indicates if we should automatically infer the options and schema for CSV and JSON sources.
                "sourceFormat": "A String", # [Optional] The format of the data files. For CSV files, specify "CSV". For datastore backups, specify "DATASTORE_BACKUP". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro, specify "AVRO". The default value is CSV.
                "destinationTable": { # [Required] The destination table to load the data into.
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
                "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_APPEND. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
                "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when running the job. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid.
                "nullMarker": "A String", # [Optional] This string will be interpreted as a null value when it appears in a CSV file. The default value is the empty string. Please refer to the documentation for further information.
                "allowJaggedRows": True or False, # [Optional] Accept rows that are missing trailing optional columns. The missing values are treated as nulls. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. Only applicable to CSV, ignored for other formats.
                "skipLeadingRows": 42, # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when loading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
                "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud Storage. Each URI can contain one '*' wildcard character and it must come after the 'bucket' name.
                  "A String",
                ],
                "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
                "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
                "schemaInlineFormat": "A String", # [Deprecated] The format of the schemaInline property.
                "schemaInline": "A String", # [Deprecated] The inline schema. For CSV schemas, specify as "Field1:Type1[,Field2:Type2]*". For example, "foo:STRING, bar:INTEGER, baz:FLOAT".
                "allowQuotedNewlines": True or False, # Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
                "projectionFields": [ # [Experimental] If sourceFormat is set to "DATASTORE_BACKUP", indicates which entity properties to load into BigQuery from a Cloud Datastore backup. Property names are case sensitive and must be top-level properties. If no properties are specified, BigQuery loads all properties. If any named property isn't found in the Cloud Datastore backup, an invalid error is returned in the job result.
                  "A String",
                ],
                "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names
                "schema": { # [Optional] The schema for the destination table. The schema can be omitted if the destination table already exists, or if you're loading data from Google Cloud Datastore.
                  "fields": [ # Describes the fields in a table.
                    {
                      "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                        # Object with schema name: TableFieldSchema
                      ],
                      "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                      "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                      "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                      "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                    },
                  ],
                },
              },
              "dryRun": True or False, # [Optional] If set, don't actually run this job. A valid query will return a mostly empty response with some processing statistics, while an invalid query will return the same error it would if it wasn't a dry run. Behavior of non-query jobs is undefined.
              "labels": { # [Experimental] The labels associated with this job. You can use these to organize and group your jobs. Label keys and values can be no longer than 63 characters, can only contain letters, numeric characters, underscores and dashes. International characters are allowed. Label values are optional. Label keys must start with a letter and must be unique within a dataset. Both keys and values are additionally constrained to be <= 128 bytes in size.
                "a_key": "A String",
              },
              "query": { # [Pick one] Configures a query job.
                "flattenResults": true, # [Optional] Flattens all nested and repeated fields in the query results. The default value is true. allowLargeResults must be true if this is set to false.
                "maximumBillingTier": 1, # [Optional] Limits the billing tier for this job. Queries that have resource usage beyond this tier will fail (without incurring a charge). If unspecified, this will be set to your project default.
                "useQueryCache": true, # [Optional] Whether to look for the result in the query cache. The query cache is a best-effort cache that will be flushed whenever tables in the query are modified. Moreover, the query cache is only available when a query does not have a destination table specified. The default value is true.
                "defaultDataset": { # [Optional] Specifies the default dataset to use for unqualified table names in the query.
                  "projectId": "A String", # [Optional] The ID of the project containing this dataset.
                  "datasetId": "A String", # [Required] A unique ID for this dataset, without the project name. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                },
                "useLegacySql": True or False, # Specifies whether to use BigQuery's legacy SQL dialect for this query. The default value is true. If set to false, the query will use BigQuery's standard SQL: https://cloud.google.com/bigquery/sql-reference/ When useLegacySql is set to false, the values of allowLargeResults and flattenResults are ignored; query will be run as if allowLargeResults is true and flattenResults is false.
                "destinationTable": { # [Optional] Describes the table where the query results should be stored. If not present, a new table will be created to store the results.
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
                "schemaUpdateOptions": [ # [Experimental] Allows the schema of the destination table to be updated as a side effect of the query job. Schema update options are supported in two cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified: ALLOW_FIELD_ADDITION: allow adding a nullable field to the schema. ALLOW_FIELD_RELAXATION: allow relaxing a required field in the original schema to nullable.
                  "A String",
                ],
                "priority": "A String", # [Optional] Specifies a priority for the query. Possible values include INTERACTIVE and BATCH. The default value is INTERACTIVE.
                "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
                "allowLargeResults": True or False, # If true, allows the query to produce arbitrarily large result tables at a slight cost in performance. Requires destinationTable to be set.
                "userDefinedFunctionResources": [ # [Experimental] Describes user-defined function resources used in the query.
                  {
                    "resourceUri": "A String", # [Pick one] A code resource to load from a Google Cloud Storage URI (gs://bucket/path).
                    "inlineCode": "A String", # [Pick one] An inline resource that contains code for a user-defined function (UDF). Providing a inline code resource is equivalent to providing a URI for a file containing the same code.
                  },
                ],
                "queryParameters": [ # Query parameters for standard SQL queries.
                  {
                    "parameterType": { # [Required] The type of this parameter.
                      "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                        {
                          "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                          "description": "A String", # [Optional] Human-oriented description of the field.
                          "name": "A String", # [Optional] The name of this field.
                        },
                      ],
                      "type": "A String", # [Required] The top level type of this field.
                      "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
                    },
                    "parameterValue": { # [Required] The value of this parameter.
                      "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                        "a_key": # Object with schema name: QueryParameterValue
                      },
                      "arrayValues": [ # [Optional] The array values, if this is an array type.
                        # Object with schema name: QueryParameterValue
                      ],
                      "value": "A String", # [Optional] The value of this value, if a simple scalar type.
                    },
                    "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
                  },
                ],
                "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
                "query": "A String", # [Required] BigQuery SQL query to execute.
                "preserveNulls": True or False, # [Deprecated] This property is deprecated.
                "maximumBytesBilled": "A String", # [Optional] Limits the bytes billed for this job. Queries that will have bytes billed beyond this limit will fail (without incurring a charge). If unspecified, this will be set to your project default.
                "tableDefinitions": { # [Optional] If querying an external data source outside of BigQuery, describes the data format, location and other properties of the data source. By defining these properties, the data source can then be queried as if it were a standard BigQuery table.
                  "a_key": {
                    "compression": "A String", # [Optional] The compression type of the data source. Possible values include GZIP and NONE. The default value is NONE. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                    "csvOptions": { # Additional properties to set if sourceFormat is set to CSV.
                      "fieldDelimiter": "A String", # [Optional] The separator for fields in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. BigQuery also supports the escape sequence "\t" to specify a tab separator. The default value is a comma (',').
                      "encoding": "A String", # [Optional] The character encoding of the data. The supported values are UTF-8 or ISO-8859-1. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties.
                      "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a CSV file that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped.
                      "allowJaggedRows": True or False, # [Optional] Indicates if BigQuery should accept rows that are missing trailing optional columns. If true, BigQuery treats missing trailing columns as null values. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false.
                      "quote": """, # [Optional] The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true.
                      "allowQuotedNewlines": True or False, # [Optional] Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false.
                    },
                    "autodetect": True or False, # [Experimental] Try to detect schema and format options automatically. Any option specified explicitly will be honored.
                    "maxBadRecords": 42, # [Optional] The maximum number of bad records that BigQuery can ignore when reading data. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups and Avro formats.
                    "ignoreUnknownValues": True or False, # [Optional] Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names Google Cloud Bigtable: This setting is ignored. Google Cloud Datastore backups: This setting is ignored. Avro: This setting is ignored.
                    "sourceUris": [ # [Required] The fully-qualified URIs that point to your data in Google Cloud. For Google Cloud Storage URIs: Each URI can contain one '*' wildcard character and it must come after the 'bucket' name. Size limits related to load jobs apply to external data sources. For Google Cloud Bigtable URIs: Exactly one URI can be specified and it has be a fully specified and valid HTTPS URL for a Google Cloud Bigtable table. For Google Cloud Datastore backups, exactly one URI can be specified, and it must end with '.backup_info'. Also, the '*' wildcard character is not allowed.
                      "A String",
                    ],
                    "bigtableOptions": { # [Optional] Additional options if sourceFormat is set to BIGTABLE.
                      "readRowkeyAsString": True or False, # [Optional] If field is true, then the rowkey column families will be read and converted to string. Otherwise they are read with BYTES type values and users need to manually cast them with CAST if necessary. The default value is false.
                      "ignoreUnspecifiedColumnFamilies": True or False, # [Optional] If field is true, then the column families that are not specified in columnFamilies list are not exposed in the table schema. Otherwise, they are read with BYTES type values. The default value is false.
                      "columnFamilies": [ # [Optional] List of column families to expose in the table schema along with their types. This list restricts the column families that can be referenced in queries and specifies their value types. You can use this list to do type conversions - see the 'type' field for more details. If you leave this list empty, all column families are present in the table schema and their values are read as BYTES. During a query only the column families referenced in that query are read from Bigtable.
                        {
                          "familyId": "A String", # Identifier of the column family.
                          "type": "A String", # [Optional] The type to convert the value in cells of this column family. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. This can be overridden for a specific column by listing that column in 'columns' and specifying a type for it.
                          "onlyReadLatest": True or False, # [Optional] If this is set only the latest version of value are exposed for all columns in this column family. This can be overridden for a specific column by listing that column in 'columns' and specifying a different setting for that column.
                          "columns": [ # [Optional] Lists of columns that should be exposed as individual fields as opposed to a list of (column name, value) pairs. All columns whose qualifier matches a qualifier in this list can be accessed as .. Other columns can be accessed as a list through .Column field.
                            {
                              "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. 'encoding' can also be set at the column family level. However, the setting at this level takes precedence if 'encoding' is set at both levels.
                              "qualifierEncoded": "A String", # [Required] Qualifier of the column. Columns in the parent column family that has this exact qualifier are exposed as . field. If the qualifier is valid UTF-8 string, it can be specified in the qualifier_string field. Otherwise, a base-64 encoded value must be set to qualifier_encoded. The column field name is the same as the column qualifier. However, if the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as field_name.
                              "fieldName": "A String", # [Optional] If the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as the column field name and is used as field name in queries.
                              "onlyReadLatest": True or False, # [Optional] If this is set, only the latest version of value in this column are exposed. 'onlyReadLatest' can also be set at the column family level. However, the setting at this level takes precedence if 'onlyReadLatest' is set at both levels.
                              "qualifierString": "A String",
                              "type": "A String", # [Optional] The type to convert the value in cells of this column. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive) - BYTES STRING INTEGER FLOAT BOOLEAN Default type is BYTES. 'type' can also be set at the column family level. However, the setting at this level takes precedence if 'type' is set at both levels.
                            },
                          ],
                          "encoding": "A String", # [Optional] The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. This can be overridden for a specific column by listing that column in 'columns' and specifying an encoding for it.
                        },
                      ],
                    },
                    "sourceFormat": "A String", # [Required] The data format. For CSV files, specify "CSV". For Google sheets, specify "GOOGLE_SHEETS". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro files, specify "AVRO". For Google Cloud Datastore backups, specify "DATASTORE_BACKUP". [Experimental] For Google Cloud Bigtable, specify "BIGTABLE". Please note that reading from Google Cloud Bigtable is experimental and has to be enabled for your project. Please contact Google Cloud Support to enable this for your project.
                    "googleSheetsOptions": { # [Optional] Additional options if sourceFormat is set to GOOGLE_SHEETS.
                      "skipLeadingRows": "A String", # [Optional] The number of rows at the top of a sheet that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows that should be skipped. When autodetect is on, behavior is the following: * skipLeadingRows unspecified - Autodetect tries to detect headers in the first row. If they are not detected, the row is read as data. Otherwise data is read starting from the second row. * skipLeadingRows is 0 - Instructs autodetect that there are no headers and data should be read starting from the first row. * skipLeadingRows = N > 0 - Autodetect skips N-1 rows and tries to detect headers in row N. If headers are not detected, row N is just skipped. Otherwise row N is used to extract column names for the detected schema.
                    },
                    "schema": { # [Optional] The schema for the data. Schema is required for CSV and JSON formats. Schema is disallowed for Google Cloud Bigtable, Cloud Datastore backups, and Avro formats.
                      "fields": [ # Describes the fields in a table.
                        {
                          "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                            # Object with schema name: TableFieldSchema
                          ],
                          "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
                          "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
                          "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
                          "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
                        },
                      ],
                    },
                  },
                },
                "parameterMode": "A String", # [Experimental] Standard SQL only. Whether to use positional (?) or named (@myparam) query parameters in this query.
              },
              "copy": { # [Pick one] Copies a table.
                "createDisposition": "A String", # [Optional] Specifies whether the job is allowed to create new tables. The following values are supported: CREATE_IF_NEEDED: If the table does not exist, BigQuery creates the table. CREATE_NEVER: The table must already exist. If it does not, a 'notFound' error is returned in the job result. The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion.
                "sourceTables": [ # [Pick one] Source tables to copy.
                  {
                    "projectId": "A String", # [Required] The ID of the project containing this table.
                    "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                    "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                  },
                ],
                "writeDisposition": "A String", # [Optional] Specifies the action that occurs if the destination table already exists. The following values are supported: WRITE_TRUNCATE: If the table already exists, BigQuery overwrites the table data. WRITE_APPEND: If the table already exists, BigQuery appends the data to the table. WRITE_EMPTY: If the table already exists and contains data, a 'duplicate' error is returned in the job result. The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion.
                "destinationTable": { # [Required] The destination table
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
                "sourceTable": { # [Pick one] Source table to copy.
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
              },
              "extract": { # [Pick one] Configures an extract job.
                "destinationUri": "A String", # [Pick one] DEPRECATED: Use destinationUris instead, passing only one URI as necessary. The fully-qualified Google Cloud Storage URI where the extracted table should be written.
                "compression": "A String", # [Optional] The compression type to use for exported files. Possible values include GZIP and NONE. The default value is NONE.
                "fieldDelimiter": "A String", # [Optional] Delimiter to use between fields in the exported data. Default is ','
                "destinationFormat": "A String", # [Optional] The exported file format. Possible values include CSV, NEWLINE_DELIMITED_JSON and AVRO. The default value is CSV. Tables with nested or repeated fields cannot be exported as CSV.
                "printHeader": true, # [Optional] Whether to print out a header row in the results. Default is true.
                "destinationUris": [ # [Pick one] A list of fully-qualified Google Cloud Storage URIs where the extracted table should be written.
                  "A String",
                ],
                "sourceTable": { # [Required] A reference to the table being exported.
                  "projectId": "A String", # [Required] The ID of the project containing this table.
                  "tableId": "A String", # [Required] The ID of the table. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
                  "datasetId": "A String", # [Required] The ID of the dataset containing this table.
                },
              },
            },
            "id": "A String", # Unique opaque ID of the job.
            "errorResult": { # A result object that will be present only if the job has failed.
              "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
              "message": "A String", # A human-readable description of the error.
              "reason": "A String", # A short error code that summarizes the error.
              "location": "A String", # Specifies where the error occurred, if present.
            },
          },
        ],
      }

`list_next(previous_request, previous_response)`

    Retrieves the next page of results.

    Args:
      previous_request: The request for the previous page. (required)
      previous_response: The response from the request for the previous page. (required)

    Returns:
      A request object that you can call 'execute()' on to request the next
      page. Returns None if there are no more items in the collection.

`query(projectId, body)`

    Runs a BigQuery SQL query synchronously and returns query results if the query completes within a specified timeout.

    Args:
      projectId: string, Project ID of the project billed for the query (required)
      body: object, The request body. (required)
        The object takes the form of:

    {
        "timeoutMs": 42, # [Optional] How long to wait for the query to complete, in milliseconds, before the request times out and returns. Note that this is only a timeout for the request, not the query. If the query takes longer to run than the timeout value, the call returns without any results and with the 'jobComplete' flag set to false. You can call GetQueryResults() to wait for the query to complete and read the results. The default value is 10000 milliseconds (10 seconds).
        "kind": "bigquery#queryRequest", # The resource type of the request.
        "dryRun": True or False, # [Optional] If set to true, BigQuery doesn't run the job. Instead, if the query is valid, BigQuery returns statistics about the job such as how many bytes would be processed. If the query is invalid, an error returns. The default value is false.
        "parameterMode": "A String", # [Experimental] Standard SQL only. Whether to use positional (?) or named (@myparam) query parameters in this query.
        "useQueryCache": true, # [Optional] Whether to look for the result in the query cache. The query cache is a best-effort cache that will be flushed whenever tables in the query are modified. The default value is true.
        "defaultDataset": { # [Optional] Specifies the default datasetId and projectId to assume for any unqualified table names in the query. If not set, all table names in the query string must be qualified in the format 'datasetId.tableId'.
          "projectId": "A String", # [Optional] The ID of the project containing this dataset.
          "datasetId": "A String", # [Required] A unique ID for this dataset, without the project name. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters.
        },
        "useLegacySql": true, # Specifies whether to use BigQuery's legacy SQL dialect for this query. The default value is true. If set to false, the query will use BigQuery's standard SQL: https://cloud.google.com/bigquery/sql-reference/ When useLegacySql is set to false, the values of allowLargeResults and flattenResults are ignored; query will be run as if allowLargeResults is true and flattenResults is false.
        "maxResults": 42, # [Optional] The maximum number of rows of data to return per page of results. Setting this flag to a small value such as 1000 and then paging through results might improve reliability when the query result set is large. In addition to this limit, responses are also limited to 10 MB. By default, there is no maximum row count, and only the byte limit applies.
        "queryParameters": [ # [Experimental] Query parameters for Standard SQL queries.
          {
            "parameterType": { # [Required] The type of this parameter.
              "structTypes": [ # [Optional] The types of the fields of this struct, in order, if this is a struct.
                {
                  "type": # Object with schema name: QueryParameterType # [Required] The type of this field.
                  "description": "A String", # [Optional] Human-oriented description of the field.
                  "name": "A String", # [Optional] The name of this field.
                },
              ],
              "type": "A String", # [Required] The top level type of this field.
              "arrayType": # Object with schema name: QueryParameterType # [Optional] The type of the array's elements, if this is an array.
            },
            "parameterValue": { # [Required] The value of this parameter.
              "structValues": { # [Optional] The struct field values, in order of the struct type's declaration.
                "a_key": # Object with schema name: QueryParameterValue
              },
              "arrayValues": [ # [Optional] The array values, if this is an array type.
                # Object with schema name: QueryParameterValue
              ],
              "value": "A String", # [Optional] The value of this value, if a simple scalar type.
            },
            "name": "A String", # [Optional] If unset, this is a positional parameter. Otherwise, should be unique within a query.
          },
        ],
        "query": "A String", # [Required] A query string, following the BigQuery query syntax, of the query to execute. Example: "SELECT count(f1) FROM [myProjectId:myDatasetId.myTableId]".
        "preserveNulls": True or False, # [Deprecated] This property is deprecated.
      }

    Returns:
      An object of the form:

        {
        "kind": "bigquery#queryResponse", # The resource type.
        "errors": [ # [Output-only] All errors and warnings encountered during the running of the job. Errors here do not necessarily mean that the job has completed or was unsuccessful.
          {
            "debugInfo": "A String", # Debugging information. This property is internal to Google and should not be used.
            "message": "A String", # A human-readable description of the error.
            "reason": "A String", # A short error code that summarizes the error.
            "location": "A String", # Specifies where the error occurred, if present.
          },
        ],
        "jobReference": { # Reference to the Job that was created to run the query. This field will be present even if the original request timed out, in which case GetQueryResults can be used to read the results once the query has completed. Since this API only returns the first page of results, subsequent pages can be fetched via the same mechanism (GetQueryResults).
          "projectId": "A String", # [Required] The ID of the project containing this job.
          "jobId": "A String", # [Required] The ID of the job. The ID must contain only letters (a-z, A-Z), numbers (0-9), underscores (_), or dashes (-). The maximum length is 1,024 characters.
        },
        "pageToken": "A String", # A token used for paging results.
        "jobComplete": True or False, # Whether the query has completed or not. If rows or totalRows are present, this will always be true. If this is false, totalRows will not be available.
        "totalRows": "A String", # The total number of rows in the complete query result set, which can be more than the number of rows in this single page of results.
        "totalBytesProcessed": "A String", # The total number of bytes processed for this query. If this query was a dry run, this is the number of bytes that would be processed if the query were run.
        "cacheHit": True or False, # Whether the query result was fetched from the query cache.
        "rows": [ # An object with as many results as can be contained within the maximum permitted reply size. To get any additional rows, you can call GetQueryResults and specify the jobReference returned above.
          {
            "f": [ # Represents a single row in the result set, consisting of one or more fields.
              {
                "v": "",
              },
            ],
          },
        ],
        "numDmlAffectedRows": "A String", # [Output-only, Experimental] The number of rows affected by a DML statement. Present only for DML statements INSERT, UPDATE or DELETE.
        "schema": { # The schema of the results. Present only when the query completes successfully.
          "fields": [ # Describes the fields in a table.
            {
              "fields": [ # [Optional] Describes the nested schema fields if the type property is set to RECORD.
                # Object with schema name: TableFieldSchema
              ],
              "type": "A String", # [Required] The field data type. Possible values include STRING, BYTES, INTEGER, INT64 (same as INTEGER), FLOAT, FLOAT64 (same as FLOAT), BOOLEAN, BOOL (same as BOOLEAN), TIMESTAMP, DATE, TIME, DATETIME, RECORD (where RECORD indicates that the field contains a nested schema) or STRUCT (same as RECORD).
              "description": "A String", # [Optional] The field description. The maximum length is 16K characters.
              "name": "A String", # [Required] The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 128 characters.
              "mode": "A String", # [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE.
            },
          ],
        },
      }